'///////////////////////////////////////////////////////////////////////////////
'//
'// Project Name : COMUtils.inc for RapidQ
'// Version      : 1.04.2006.20
'// Author       : Don67geo@Yahoo.com
'// Date         : April 20th, 2006
'//
'///////////////////////////////////////////////////////////////////////////////
$typecheck ON

$ifndef COMUTILS_INC
$define COMUTILS_INC

declare function STDCall lib "user32" alias "CallWindowProcA" _
            (fnPtr as long, p1 as long, p2 as long, p3 as long, _
             p4 as long) as long

defbyte MCallOpcodes (0 To 51) = _
    { _
      &H55,&H89,&HE5,&H8B,&H75,&H08,&H8B,&H06, _
      &H89,&HC3,&HC1,&HE0,&H02,&H01,&HC6,&H81, _
      &HFB,&H00,&H00,&H00,&H00,&H74,&H0B,&HFF, _
      &H36,&H81,&HEE,&H04,&H00,&H00,&H00,&H4B, _
      &H75,&HF5,&H8B,&H45,&H0C,&H8B,&H4D,&H10, _
      &H50,&H8B,&H00,&HFF,&H14,&H08,&H89,&HEC, _
      &H5D,&HC2,&H10,&H00 _
    }
' ----- POINTER to use In CallAsmProc -----
defint pMCall = varptr(MCallOpcodes(0))

'
' Syntax: 
'         ComCall(Vtbl_Offset,ObjectPtr,Arg1, ..., ArgN)
'         'or
'         A=ComCall(Vtbl_Offset,ObjectPtr,Arg1, ..., ArgN)
functioni ComCall (...) as long
      defint n
      dim Arg(0 to (ParamValCount-2)) as long
      if ParamValCount < 2 then
         result = 0
         exit function
      end if
      Arg(0) = ParamValCount-2      ' Arg Number
      if ParamValCount > 2 then
         for n = 3 to ParamValCount
             Arg(n-2) = ParamVal(n)
         next n
      end if
      result=STDCall(pMCall,varptr(Arg(0)),ParamVal(2),ParamVal(1),0)
end function

$endif 'COMUTILS_INC 
