$TYPECHECK ON
$INCLUDE "RapidQ2.inc"
DECLARE SUB LoadImage
DECLARE SUB BlendTwoImages

DIM TmpBMP AS QBITMAPex
DIM Src1 AS QBITMAPex 'source 1 for bitmap 
DIM Src2 AS QBITMAPex 'source 2 for bmp blending
DIM fDialog as QFILEDIALOG

CREATE form as QFORM
  width = Screen.Width
  height = Screen.Height - 28
  OnClick = BlendTwoImages

create canvas as QCanvas
  Top = 24
  width = Form.ClientWidth
  height = Form.ClientHeight - 45
  OnClick = BlendTwoImages
end create 
end create
Form.ShowModal

SUB LoadImage
  fDialog.Caption = "Open files"
  fDialog.filter =  "Picture files|*.BMP;*.ICO;*.JPG;*.GIF;*.DIB;*.RLE;*.TGA;*.PCX"
  fDialog.FileName= ""
  IF fDialog.Execute THEN
	TmpBMP.LoadOtherImage(fDialog.FileName, 0,"")
    Canvas.Draw(0,0, TmpBMP.BMP)
  END IF
END SUB


SUB BlendTwoImages
  fDialog.Caption = "Open two Bitmap files"
  fDialog.filter =  "Picture files|*.BMP;*.ICO;*.JPG;*.GIF;*.DIB;*.RLE;*.TGA;*.PCX"
  fDialog.FileName= ""
  fDialog.Multiselect = 1
  IF fDialog.Execute THEN
    Src1.LoadOtherImage(fDialog.Files(0) +"\"+fDialog.Files(1), 0, "")
    Src2.LoadOtherImage(fDialog.Files(0) +"\"+fDialog.Files(2), 0, "")
    TmpBMP.AlphaBlend(Src1, Src2, 0.5) 'mix 50-50%
    Canvas.Draw(0,0, TmpBMP.BMP)					'this only works with BMP?
  END IF
END SUB
