$ESCAPECHARS ON
DECLARE SUB Init
DECLARE SUB Key1(Key AS WORD, Shift AS SHORT)
DECLARE SUB Key2(Key AS WORD, Shift AS SHORT)
DECLARE SUB Key3(Key AS BYTE)
DECLARE SUB ClearFields

CREATE Form AS QFORM
    Width = 220
    Height = 130
    BorderStyle = 4
    CREATE Label AS QLABEL
       Top = 9
       Left = 10
       Caption = "OnKeyDown\n\nOnKeyUp\n\nOnKeyPress"
    END CREATE
    CREATE Edit1 AS QEDIT
       Top = 7
       Left = 80
       ReadOnly = 1
       Enabled = 0
    END CREATE
    CREATE Edit2 AS QEDIT
       Top = 32
       Left = 80
       ReadOnly = 1
       Enabled = 0
    END CREATE
    CREATE Edit3 AS QEDIT
       Top = 58
       Left = 80
       ReadOnly = 1
       Enabled = 0
    END CREATE
    CREATE Trap AS QRADIOBUTTON
       Top = 90
       Left = 20
       Checked = 1
       Caption = "Trap Keys"
       ShowHint = 1
       Hint = "Shows how the different\nkey trap events _
              act\ndifferently with some keys"
    END CREATE
    CREATE Clear AS QRADIOBUTTON
       Top = 90
       Left = 100
       Caption = "Clear Fields"
       ShowHint = 1
       Hint = "Some events don't trap\nsome keys - _
              starting\nwith blank fields will\nshow _
              which ones"
       OnClick = ClearFields
    END CREATE
    KeyPreview = 1
    OnShow = Init
    OnKeyDown = Key1
    OnKeyUp = Key2
    OnKeyPress = Key3
    Center
    ShowModal
END CREATE

SUB Init
    Application.HintHidePause = 10000
    Application.HintShortPause = 1000
END SUB

SUB Key1(Key, Shift)
    Edit1.Text = "Key " + STR$(Key) + "  Shift " + STR$(Shift)
END SUB

SUB Key2(Key, Shift)
    Edit2.Text = "Key " + STR$(Key) + "  Shift " + STR$(Shift)
END SUB

SUB Key3(Key)
    Edit3.Text = "Key " + STR$(Key)
END SUB

SUB ClearFields
    IF Clear.Checked = 1 THEN
       Edit1.Text = ""
       Edit2.Text = ""
       Edit3.Text = ""
       Clear.Enabled = 0
       Trap.Checked = 1
       Clear.Enabled = 1
    END IF
END SUB
