$INCLUDE "RapidQ.inc"

'--- properties --------------
defint RowCount=7 
defint ColCount=5
defint DefaultColWidth=64
defint DefaultRowHeight=24

defint GridLineWidth=1
defint GridLineColor=cldgreen
defint GridWidth=GridLineWidth*(ColCount+1)+DefaultColWidth*ColCount
defint GridHeight =GridLineWidth*(RowCount+1)+DefaultRowHeight*RowCount
defint GridColor=&HBAFCE7'cllRed

defint cellAlignment=taCenter 
defint SelectedBGColor=clyellow

defint SelCol,SelRow

'!!! --- Merge ---------------------------------
defint MergeStartCol=1
defint MergeStartRow=1

defint MergeCountCol=3
defint MergeCountRow=3
'-----------------------------------------------

declare sub SelectCell ( Sender as QLabel)'Col%, Row%, CanSelect%,
'declare sub DrawCell (Sender as QLabel)

declare sub CellOnMouseDown (Button%, X%, Y%, Shift%, Sender as QLabel)
declare sub CellOnMouseUp (Button%, X%, Y%, Shift%,Sender as QLabel)

CREATE Form AS QFORM
    Caption = "LabelGrid"
    Width = 420
    Height = 340
		FormStyle = fsStayOnTop
    Center
CREATE PanelGrid AS QPANEL
        Left =2
        Top = 2
			Width=GridWidth
			Height=GridHeight
			
        Caption = "Panel1"
        TabOrder = 8
			color=GridLineColor
			BevelOuter =bvnone
			BevelInner=bvnone
END CREATE
END CREATE

dim Labels(RowCount,ColCount) as QLabel
k=0

for i=0 to  RowCount-1
	for j=0 to  ColCount-1
		Labels(i,j).parent=PanelGrid
		Labels(i,j).tag=-k
		Labels(i,j).Autosize=0
		Labels(i,j).Alignment=cellAlignment
		Labels(i,j).left=GridLineWidth*(j+1)+DefaultColWidth*j
		Labels(i,j).top=GridLineWidth*(i+1)+DefaultRowHeight*i
		Labels(i,j).caption=str$(Labels(i,j).top)
		Labels(i,j).OnClick=SelectCell
		Labels(i,j).color=GridColor
		Labels(i,j).Height=DefaultRowHeight
		Labels(i,j).Width=DefaultColWidth

		if i>=MergeStartRow  and i<MergeStartRow+MergeCountRow and j>=MergeStartCol and j<MergeStartCol+MergeCountCol then
			Labels(i,j).caption="Merged"
			Labels(i,j).visible =0
			Labels(i,j).color=clLBlue
		end if

		if i=MergeStartRow and j=MergeStartRow then
			Labels(i,j).Height=GridLineWidth*(MergeCountRow-1)+DefaultRowHeight*MergeCountRow
			Labels(i,j).Width=GridLineWidth*(MergeCountCol-1)+DefaultColWidth*MergeCountCol 
			Labels(i,j).color=clred
			Labels(i,j).visible =1
		end if
		inc k
	next j
next i

 Form.ShowModal 

'**********************************************************************
sub CellOnMouseDown (Button%, X%, Y%, Shift%,Sender as QLabel)
'Sender.Color=SelectedBGColor
Sender.caption=str$(X%)+"\"+str$(Y%)
end sub

'**********************************************************************
sub CellOnMouseUp (Button%, X%, Y%, Shift%,Sender as QLabel)
'Sender.Color=GridColor
end sub

'**********************************************************************
sub SelectCell ( Sender as QLabel)'Col%, Row%, CanSelect%,
Labels(SelRow,SelCol).Color=GridColor

for i=0 to  RowCount-1
for j=0 to  ColCount-1

if Sender.tag=Labels(i,j).tag  then
	SelCol=j 
	SelRow=i
else
end if

next j
next i

Sender.color=SelectedBGColor

end sub

   