'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Simple Address Book
' Sample program for QfileStream, UDTs
' Mesut Akcan
' 10 Sept. 2000
' http://kaynak.cjb.net
' makcan@softhome.net
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$INCLUDE "RAPIDQ.INC"
$TypeCheck On

DECLARE SUB SetFocus LIB "USER32" ALIAS "SetFocus" (HWnd AS LONG)
DECLARE SUB RNew
DECLARE SUB RSave
DECLARE SUB RDelete

DECLARE SUB FClose
DECLARE SUB RNo
DECLARE SUB edRnoKeyP (Key AS BYTE)
DECLARE SUB RRead(no as long)
DECLARE SUB btnClick(sender as Qbutton)

Type tRecord
    name as string * 18
    lastn as string * 18
    tel1 as string * 18
    tel2 as string * 18
    addr as string * 50
End Type

CREATE Form AS QFORM
    Caption = "Simple Address Book"
    Borderstyle = 1
    DelBorderIcons(2)
    Width = 255
    Height = 273
    Center
    CREATE Label1 AS QLABEL
        Caption = "Rec.No:"
        Left = 4
        Top = 8
        Width = 40
    END CREATE
    CREATE Label2 AS QLABEL
        Caption = "Name"
        Left = 4
        Top = 32
        Width = 40
    END CREATE
    CREATE Label3 AS QLABEL
        Caption = "Last name"
        Left = 4
        Top = 56
        Width = 56
    END CREATE
    CREATE Label4 AS QLABEL
        Caption = "T.phone1"
        Left = 4
        Top = 80
        Width = 48
        END CREATE
    CREATE Label5 AS QLABEL
        Caption = "T.phone2"
        Left = 4
        Top = 104
        Width = 56
    END CREATE
    CREATE Label6 AS QLABEL
        Caption = "Address"
        Left = 4
        Top = 152
        Width = 40
    END CREATE
    CREATE edRno AS Qedit
        Left = 59
        Top = 5
        Width = 56
        OnKeypress = edRnoKeyP
    END CREATE
    CREATE Edit1 AS QEDIT
        Left = 59
        Top = 28
        Width = 180
        TabOrder = 0
    END CREATE
    CREATE Edit2 AS QEDIT
        Left = 59
        Top = 52
        Width = 180
        TabOrder = 1
    END CREATE
    CREATE Edit3 AS QEDIT
        Left = 59
        Top = 76
        Width = 180
        TabOrder = 2
    END CREATE
    CREATE Edit4 AS QEDIT
        Left = 59
        Top = 100
        Width = 180
        TabOrder = 3
    END CREATE
    CREATE RichEdit1 AS QRICHEDIT
        Left = 59
        Top = 125
        Width = 180
        Height = 75
        PlainText = True
        ScrollBars = ssVertical
        TabOrder = 4
    END CREATE
    CREATE btnGet AS Qbutton
        Caption = "&Get"
        Left = 125
        Top = 4
        Width = 56
        Height = 22
        Tag = 0
        OnClick = btnClick
    END CREATE
    CREATE Button1 AS QBUTTON
        Caption = "&New"
        Left = 9
        Top = 212
        Width = 43
        TabOrder = 5
        font.bold = True
        Tag = 1
        OnClick = btnClick
    END CREATE
    CREATE Button2 AS QBUTTON
        Caption = "&Save"
        Left = 57
        Top = 212
        Width = 43
        TabOrder = 6
        font.bold = True
        Tag = 2
        OnClick = btnClick
    END CREATE
    CREATE Button3 AS QBUTTON
        Caption = "&Delete"
        Left = 105
        Top = 212
        Width = 43
        TabOrder = 7
        font.bold = True
        Tag = 3
        OnClick = btnClick
    END CREATE
    CREATE Button4 AS QBUTTON
        Caption = "|<"
        Left = 153
        Top = 212
        Width = 19
        TabOrder = 8
        font.bold = True
        Tag = 4
        OnClick = btnClick
    END CREATE
    CREATE Button5 AS QBUTTON
        Caption = "<"
        Left = 177
        Top = 212
        Width = 19
        TabOrder = 9
        font.bold = True
        Tag = 5
        OnClick = btnClick
    END CREATE
    CREATE Button6 AS QBUTTON
        Caption = ">"
        Left = 201
        Top = 212
        Width = 19
        TabOrder = 10
        font.bold = True
        Tag = 6
        OnClick = btnClick
    END CREATE
    CREATE Button7 AS QBUTTON
        Caption = ">|"
        Left = 225
        Top = 212
        Width = 19
        TabOrder = 11
        font.bold = True
        Tag = 7
        OnClick = btnClick
    END CREATE
    onClose = FClose
    END CREATE

Dim person as tRecord
Dim file as QFileStream 
Dim rsize as Word, recno as long

chdir (command$(0)-application.exename)
 
rsize = sizeof(person)
defstr fName = "rec.dat"
IF FileExists(fName) = FALSE THEN file.open(fName,fmCreate):file.close
file.open(fName,fmOpenReadWrite)
Call Rnew

Form.ShowModal
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub btnClick (Sender as Qbutton)
    Select Case Sender.Tag
        Case 0: Call RRead(val(edRno.text)-1)    ' Get
        Case 1: Call RNew                        ' New
        Case 2: Call RSave                       ' Save
        Case 3: Call RDelete                     ' Delete
        Case 4: Call RRead(0)                    ' First
        Case 5: Call RRead(recno-1)              ' Prev.  
        Case 6: Call RRead(recno+1)              ' Next  
        Case 7: Call RRead(file.size\rsize-1)    ' Last
    End Select
End Sub

SUB RNew    'New Click
    edit1.text = ""
    edit2.text = ""
    edit3.text = ""
    edit4.text = ""
    richedit1.text=""
    recno = file.size\rsize
    Call RNo
    SetFocus(edit1.handle)
END SUB

SUB RSave 'Save Click
    with person
        .name = edit1.text
        .lastn = edit2.text
        .tel1 = edit3.text
        .tel2 = edit4.text
        .addr = richedit1.text
    end with
    file.position = recno  * rsize 
    file.WriteUDT(person)
    Call RNew
END SUB

SUB RDelete 'Delete Click
    dim kno as long, n as long ,lastRno as long
    kno = val(edRno.text)-1
    lastRno = file.size\rsize-1
    if (kno<0) or (kno>lastRno) then 
        showmessage "Bad Record Number !"
        exit sub
    end if
    dim file2 as qfilestream
    defstr f2name = "~temp.tmp"
    file2.open(f2name,fmCreate)
    for n = 0 to lastRno
        if n<>kno then
            file.position = n * rsize
            file2.CopyFrom(File,rsize)
        end if
    next
    file2.close
    file.close
    kill fName 
    rename f2name, fName 
    file.open(fName,fmOpenReadWrite) 
    if kno<>0 then kno--
    Call RRead(kno)
END SUB

SUB RRead(no as long) ' Read Record
    dim poz as long
    poz = no * rsize 
    if (poz<0) or (poz>(file.size-1)) then
        sound 4000,3
        exit sub
    end if
    file.position = poz
    file.readUDT(person)
    with person
        edit1.text = .name 
        edit2.text = .lastn 
        edit3.text = .tel1  
        edit4.text = .tel2  
        richedit1.text = .addr 
    end with
    recno = no
    Call RNo
END SUB    

SUB edRnoKeyP (Key AS BYTE) ' if press Enter key
    if key = 13 then Call btnClick(btnGet) 'Get Button, key13 = Enter
END SUB

SUB RNo : edRno.text = str$(recno+1):END SUB
SUB FClose : file.close : END SUB    
