Declare sub QBase64_Callback

TYPE QBase64 extends QOBJECT
src as qmemorystream
dest as qmemorystream

'______________________________________________________________________________
Sub GetSrcFile (sourcefile as string)
dim f as qfilestream
f.open (sourcefile, 0)
f.position = 0
QBase64.src.copyfrom(f, f.size)
f.close
End Sub

'______________________________________________________________________________
Sub Encode
dim ch (0 to 64) as string
initarray (ch, _
"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", _
"Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", _
"g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", _
"w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "+", "/")

dim bytesleft as integer
bytesleft = Qbase64.src.size
qbase64.src.position = 0
qbase64.dest.position = 0

Dim decoded as integer
dim temp as integer
dim enc1 as byte
dim enc2 as byte
dim enc3 as byte
dim enc4 as byte

while bytesleft > 0
    if bytesleft < 3 then
        if bytesleft = 2 then

        decoded = qbase64.src.readnum(1) * 65536
        decoded = decoded + (qbase64.src.readnum(1) * 256)

        enc1 = floor(decoded / (64^3))
        temp = enc1 * (64^3)

        enc2 = floor((decoded - temp) / (64^2))
        temp = temp + (enc2 * (64^2))

        enc3 = floor((decoded - temp) / 64)
        temp = temp + (enc3 * 64)

        qbase64.dest.writestr( ch(enc1) & ch(enc2) & ch(enc3) & "=", 4)

        elseif bytesleft = 1 then

        decoded = qbase64.src.readnum(1) * 65536

        enc1 = floor(decoded / (64^3))
        temp = enc1 * (64^3)

        enc2 = floor((decoded - temp) / (64^2))
        temp = temp + (enc2 * (64^2))

        qbase64.dest.writestr(ch(enc1) & ch(enc2) & "==", 4)
        end if

    exit while
    end if

decoded = qbase64.src.readnum(1) * 65536
decoded = decoded + (qbase64.src.readnum(1) * 256)
decoded = decoded + qbase64.src.readnum(1)

enc1 = floor(decoded / (64^3))
temp = enc1 * (64^3)

enc2 = floor((decoded - temp) / (64^2))
temp = temp + (enc2 * (64^2))

enc3 = floor((decoded - temp) / 64)
temp = temp + (enc3 * 64)

enc4 = decoded - temp

qbase64.dest.writestr(ch(enc1) & ch(enc2) & ch(enc3) & ch(enc4), 4)
QBase64_Callback

bytesleft = bytesleft - 3
wend
End Sub

'______________________________________________________________________________
Function outstr as string
Qbase64.dest.position = 0
result = Qbase64.dest.readstr(b64.dest.size)
end function

'______________________________________________________________________________
Function OutChunks (length as integer) as string
dim temp as string

Qbase64.dest.position = 0
temp = Qbase64.dest.readstr(b64.dest.size)

dim nchunks as integer
nchunks = floor(len(temp) / length)

dim i as integer

for i = 1 to nchunks
temp = insert$(chr$(10), temp, (length * i) + i)
next

result = temp
end function

'______________________________________________________________________________
Function t_dec (in as integer) as integer

select case in
    case 43
    result = 62
    
    case 47
    result = 63

    case 61
    result = -1

    case 48, 49, 50, 51, 52, 53, 54, 55, 56, 57
    result = (in - 48 + 52)

    case 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, _
         79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90
    result =(in - 65)

    case 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, _
         112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122

    result = (in - 97 + 26)
    case else
    result = -2

end select
end function

'______________________________________________________________________________
Sub decode
QBase64.src.position = 0
dim bytesleft as integer
bytesleft = Qbase64.src.size
qbase64.src.position = 0
qbase64.dest.position = 0
dim num as integer
dim n as integer

dim dec1 as integer
dim dec2 as integer
dim dec3 as integer
dim temp as integer
dim found as integer
found = 0

dim pad as integer
n = -2

    while qbase64.src.position < qbase64.src.size

    do
    n = qbase64.src.readnum(1)
    n = Qbase64.t_dec(n)
    if n = -2 then print "Non valido", qbase64.src.position
    loop until n > -2

    if found = 3 then
        if n > -1 then
        num = num + n
        else
        pad = 1
        end if
    inc(found)
    elseif found = 2 then
        if n > -1 then
        num = num + (n * 64 )
        else
        pad = 2
        end if
    inc(found)
    elseif found = 1 then
    num = num + (n * (64 ^2))
    inc(found)
    elseif found = 0 then
    num = n *(64^3)
    inc(found)
    end if


    if found = 4 then
    dec1 = floor (num / 65536)
    temp = dec1 * 65536

    dec2 = floor ((num - temp) / 256)
    temp = temp + dec2 * 256

    dec3 = num - temp

    qbase64.dest.writenum(dec1, 1)
    if pad < 2 then qbase64.dest.writenum(dec2, 1)
    if pad < 1 then qbase64.dest.writenum(dec3, 1)

    found = 0
    end if

    QBase64_Callback
    wend


end sub

END TYPE
