' SQLITE demo
' by Jef Rozenski JAN 2004
' needs sqlite3.dll
' see http://www.sqlite.org/
' see also listview gui demos
'
GUI "SQLITE_BASE"

CONST quote$ = CHR$(34)
DIM Form1   AS HWND
DIM Button1 AS HWND
DIM Button2 AS HWND
DIM Button3 AS HWND
DIM Combo1  AS HWND
DIM Listv1  AS HWND
DIM astring$
DIM rc AS LONG
DIM dbHandle AS LONG
DIM CURRENTPOS

SUB FORMLOAD
  Form1   = BCX_FORM("SQLITE_BASE",0,0,300,120)
  Button1 = BCX_BUTTON("Create"     ,Form1,101,5,20,50,12)
  Button2 = BCX_BUTTON("DLL version",Form1,102,5,40,50,12)
  Button3 = BCX_BUTTON("Exec SQL"   ,Form1,103,5,80,50,12)
  Combo1  = BCX_COMBOBOX(""         ,Form1,104,5,60,120,100)
  Listv1  = BCX_CONTROL(WC_LISTVIEW, Form1, "", 110, 135, 5, 155, 100, _
  WS_CHILD | WS_VISIBLE | WS_TABSTOP | LVS_REPORT | LVS_SINGLESEL | LVS_SHOWSELALWAYS, _
  WS_EX_CLIENTEDGE)
  ModListView(Listv1)
  ModCombo(Combo1)
  rc = sqlite3_open(LIB "sqlite3.dll","sq3.db",&dbHandle)   ' open a database
  CENTER(Form1)
  SHOW(Form1)
END SUB

BEGIN EVENTS
  SELECT CASE CBMSG
    '----------------
  CASE WM_COMMAND
    '----------------
    IF CBCTL = 101 THEN  
      SQEXEC("CREATE TABLE test (item varchar primary key, color text, price real);")
      IF rc = 0 THEN       ' add some data (only the first time)
        SQEXEC("BEGIN;")
        SQEXEC("INSERT INTO test VALUES ('apple1a','green',0.95);")
        SQEXEC("INSERT INTO test VALUES ('apple2a','red',0.85);")
        SQEXEC("INSERT INTO test VALUES ('apple3a','blue',0.85);")
        SQEXEC("INSERT INTO test VALUES ('apple4a','red',0.85);")
        SQEXEC("INSERT INTO test VALUES ('apple5a','green',0.85);")
        SQEXEC("INSERT INTO test VALUES ('apple6a','red',0.85);")
        SQEXEC("INSERT INTO test VALUES ('apple7a','blue',0.85);")
        SQEXEC("INSERT INTO test VALUES ('apple8a','red',0.85);")
        SQEXEC("INSERT INTO test VALUES ('apple9a','green',0.85);")
        SQEXEC("INSERT INTO test VALUES ('tomato1a','green',0.65);")
        SQEXEC("INSERT INTO test VALUES ('tomato2a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('tomato3a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('tomato4a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('tomato5a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('tomato6a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('tomato7a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('tomato8a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('tomato9a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('strawberry1a','red',0.15);")
        SQEXEC("INSERT INTO test VALUES ('strawberry2a','red',0.25);")
        SQEXEC("INSERT INTO test VALUES ('strawberry3a','red',0.35);")
        SQEXEC("INSERT INTO test VALUES ('strawberry4a','red',0.45);")
        SQEXEC("INSERT INTO test VALUES ('strawberry5a','red',0.55);")
        SQEXEC("INSERT INTO test VALUES ('strawberry6a','red',0.65);")
        SQEXEC("INSERT INTO test VALUES ('strawberry7a','red',0.75);")
        SQEXEC("INSERT INTO test VALUES ('strawberry8a','red',0.85);")
        SQEXEC("INSERT INTO test VALUES ('strawberry9a','red',0.95);")
        SQEXEC("INSERT INTO test VALUES ('banana1a','yellow',1.15);")
        SQEXEC("INSERT INTO test VALUES ('banana2a','yellow',1.25);")
        SQEXEC("INSERT INTO test VALUES ('banana3a','yellow',1.35);")
        SQEXEC("INSERT INTO test VALUES ('banana4a','yellow',1.45);")
        SQEXEC("INSERT INTO test VALUES ('banana5a','yellow',1.55);")
        SQEXEC("INSERT INTO test VALUES ('banana6a','yellow',1.65);")
        SQEXEC("INSERT INTO test VALUES ('banana7a','yellow',1.75);")
        SQEXEC("INSERT INTO test VALUES ('banana8a','yellow',1.85);")
        SQEXEC("INSERT INTO test VALUES ('banana9a','yellow',1.95);")
        SQEXEC("INSERT INTO test VALUES ('pineapple1','yellow',1.15);")
        SQEXEC("INSERT INTO test VALUES ('pineapple2','yellow',1.25);")
        SQEXEC("INSERT INTO test VALUES ('pineapple3','yellow',1.35);")
        SQEXEC("INSERT INTO test VALUES ('pineapple4','yellow',1.45);")
        SQEXEC("INSERT INTO test VALUES ('pineapple5','yellow',1.55);")
        SQEXEC("INSERT INTO test VALUES ('pineapple6','yellow',1.65);")
        SQEXEC("INSERT INTO test VALUES ('pineapple7','yellow',1.75);")
        SQEXEC("INSERT INTO test VALUES ('pineapple8','yellow',1.85);")
        SQEXEC("INSERT INTO test VALUES ('pineapple9','yellow',1.95);")
        SQEXEC("INSERT INTO test VALUES ('beans1','green',0.35);")
        SQEXEC("INSERT INTO test VALUES ('beans2','yellow',0.40);")
        SQEXEC("INSERT INTO test VALUES ('beans3','red',2.00);")
        SQEXEC("INSERT INTO test VALUES ('beans4','blue',1.40);")
        SQEXEC("INSERT INTO test VALUES ('beans5','yellow',5.45);")
        SQEXEC("INSERT INTO test VALUES ('beans6','yellow',0.40);")
        SQEXEC("INSERT INTO test VALUES ('beans7','yellow',0.40);")
        SQEXEC("INSERT INTO test VALUES ('beans8','yellow',0.40);")
        SQEXEC("INSERT INTO test VALUES ('beans9','yellow',0.40);")
        SQEXEC("INSERT INTO test VALUES ('dairy1','yellow',0.40);")
        SQEXEC("INSERT INTO test VALUES ('dairy2','red',0.60);")
        SQEXEC("INSERT INTO test VALUES ('dairy3','blue',0.80);")
        SQEXEC("INSERT INTO test VALUES ('dairy4','green',0);")
        SQEXEC("COMMIT;")
      END IF
      astring$ = "SELECT * FROM test"
      ExecSQL(astring$)
    END IF
    IF CBCTL = 102 THEN  
      astring$ = sqlite3_libversion(LIB "sqlite3.dll")
      MSGBOX "DLL version: " & astring$
    END IF
    IF CBCTL = 103 THEN
      rc = SendMessage(Combo1,CB_GETCURSEL,0,0)
      IF rc >= 0 THEN
        SendMessage(Combo1,CB_GETLBTEXT,rc,(LPCSTR) astring$)
      ELSE
        astring$ = ""
      END IF
      ExecSQL(astring$)
    END IF
    EXIT FUNCTION
    '--------------
  CASE WM_CLOSE
    '--------------
    sqlite3_close(LIB "sqlite3.dll",dbHandle)   ' close the database
    DestroyWindow (Form1)
    EXIT FUNCTION
    '--------------
  CASE WM_DESTROY
    '--------------
    PostQuitMessage(0)
    EXIT FUNCTION
  END SELECT
END EVENTS

SUB ModListView(hWnd AS HWND)
  LOCAL lvStyle
  GLOBAL lvCol AS LV_COLUMN
  SendMessage(hWnd, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT),0)
  lvStyle = LVS_EX_GRIDLINES OR LVS_EX_FULLROWSELECT
  SendMessage(hWnd,LVM_SETEXTENDEDLISTVIEWSTYLE, 0, lvStyle)
  lvCol.mask      =  LVCF_FMT OR LVCF_WIDTH OR LVCF_TEXT OR LVCF_SUBITEM
  lvCol.fmt       =  LVCFMT_LEFT
  lvCol.cx        =  100
  lvCol.pszText   =  "Item"
  lvCol.iSubItem  =   0
  ListView_InsertColumn(hWnd, 0, &lvCol)
  lvCol.cx        =  100
  lvCol.pszText   = "Color"
  lvCol.iSubItem  =  1
  ListView_InsertColumn(hWnd, 1, &lvCol)
  lvCol.cx        =  100
  lvCol.pszText   = "Price"
  lvCol.iSubItem  =  2
  ListView_InsertColumn(hWnd, 2, &lvCol)
END SUB

SUB ModCombo(hWnd AS HWND)                            ' some predefined SQL statements
  astring$ = "SELECT * FROM test ORDER BY ITEM;"
  SendMessage(hWnd,CB_ADDSTRING,0,astring$)
  astring$ = "SELECT * FROM test ORDER BY COLOR;"
  SendMessage(hWnd,CB_ADDSTRING,0,astring$)
  astring$ = "SELECT * FROM test ORDER BY PRICE;"
  SendMessage(hWnd,CB_ADDSTRING,0,astring$)
  astring$ = "SELECT * FROM test WHERE color = 'red';"
  SendMessage(hWnd,CB_ADDSTRING,0,astring$)
  astring$ = "SELECT * FROM test WHERE color = 'blue';"
  SendMessage(hWnd,CB_ADDSTRING,0,astring$)
  astring$ = "SELECT * FROM test WHERE color = 'green';"
  SendMessage(hWnd,CB_ADDSTRING,0,astring$)
  astring$ = "SELECT * FROM test WHERE color = 'yellow';"
  SendMessage(hWnd,CB_ADDSTRING,0,astring$)
  astring$ = "SELECT * FROM test WHERE item LIKE 'b%'"
  SendMessage(hWnd,CB_ADDSTRING,0,astring$)
END SUB

FUNCTION MyCallback(lpv AS LPVOID,cols AS INT,lpdata[] AS LPSTR,colnames[] AS LPSTR) AS INTEGER
  '
  ' this function is executed for each hit from an sqlite3_exec call
  '
  DIM lvItem AS LV_ITEM
  LOCAL i
  lvItem.mask       =  LVIF_TEXT    ' sqlite data is stored as text
  lvItem.iItem      =  CURRENTPOS   ' position where to insert
  ListView_InsertItem(Listv1,&lvItem)
  FOR i = 0 TO cols-1
    ListView_SetItemText(Listv1,CURRENTPOS,i,lpdata[i])  ' put text in listview
  NEXT
  INCR(CURRENTPOS)
  FUNCTION = 0
END FUNCTION

FUNCTION ExecSQL(SQLstring$) AS INTEGER                ' execute SQL command
  ListView_DeleteAllItems(Listv1)                        ' first clear listview
  CURRENTPOS = 0                                         ' current insert position for listview
  FUNCTION = sqlite3_exec(LIB "sqlite3.dll",dbHandle,SQLstring$,MyCallback,NULL,NULL)
END FUNCTION

FUNCTION SQEXEC(aStr$) AS LONG
  DIM ret AS LONG
  ret = sqlite3_exec(LIB "sqlite3.dll",dbHandle,aStr$,NULL,NULL,NULL)
  FUNCTION = ret
END FUNCTION
