' (c) Fernando Perez Rios - Santander (SPAIN) - Enero 2006
'  qDataBase_v1.inc == Bases de datos MDB de Access en RapidQ
'  Based in ODBC.inc - (Open DataBase Connectivity)

$TYPECHECK ON
$IFNDEF BOOLEAN
   $DEFINE BOOLEAN INTEGER
$ENDIF
$IFNDEF False
   $DEFINE False 0
$ENDIF
$IFNDEF True
   $DEFINE True 1
$ENDIF

' CONST False           = 0
' CONST True            = 1
CONST MAX_DATA_BUFFER = 255
CONST ODBC_ADD_DSN    = 1
CONST NULL_HANDLE     = ""

' ======================================
' =        ODBC API Const:             =
' ======================================
CONST SQL_SUCCESS           =   0
CONST SQL_SUCCESS_WITH_INFO =   1
CONST SQL_ERROR             =  -1
CONST SQL_NO_DATA           = 100

' SQLAllocHandle reemplaza SQLAllocConnect, SQLAllocEnv y SQLAllocStmt.
CONST SQL_HANDLE_ENV  = 1
CONST SQL_HANDLE_DBC  = 2
CONST SQL_HANDLE_STMT = 3
CONST SQL_HANDLE_DESC = 4

CONST SQL_INVALID_HANDLE = -2
CONST SQL_NULL_HANDLE    =  0&

CONST SQL_ATTR_ODBC_VERSION = 200
CONST SQL_OV_ODBC2          = 2&
CONST SQL_OV_ODBC3          = 3&
CONST SQL_LOGIN_TIMEOUT     = 103

CONST SQL_CHAR    = 1
CONST SQL_INTEGER = 4
CONST SQL_DOUBLE  = 8

CONST SQL_ATTR_CURSOR_TYPE     = 6
CONST SQL_CURSOR_KEYSET_DRIVEN = 1

CONST SQL_FETCH_NEXT     = 1
CONST SQL_FETCH_FIRST    = 2
CONST SQL_FETCH_LAST     = 3
CONST SQL_FETCH_PRIOR    = 4
CONST SQL_FETCH_ABSOLUTE = 5
CONST SQL_FETCH_RELATIVE = 6
CONST SQL_FETCH_RESUME   = 7
CONST SQL_FETCH_PREV     = 8

CONST SQL_POSITION = 0
CONST SQL_REFRESH  = 1
CONST SQL_UPDATE   = 2
CONST SQL_DELETE   = 3

CONST SQL_LOCK_NO_CHANGE = 0
CONST SQL_LOCK_EXCLUSIVE = 1
CONST SQL_LOCK_UNLOCK    = 2

DECLARE FUNCTION IsNumeric(cText AS STRING) AS INTEGER
DECLARE FUNCTIONI ptrUDT(...) AS LONG
DECLARE SUB Error(STMT)

' ======================================
' =        ODBC API functions:         =
' ======================================
DECLARE FUNCTION SQLAllocHandle _
        Lib "odbc32.dll" _
        Alias "SQLAllocHandle" _
       (HandleType AS INTEGER, _
        InHandle   AS INTEGER, _
        OutHandle  AS LONG) _
                   AS SHORT

DECLARE FUNCTION SQLBindCol _
        Lib "odbc32.dll" _
        Alias "SQLBindCol" _
       (StatementHandle AS LONG, _
        ColumnNumber    AS INTEGER, _
        TargetType      AS INTEGER, _
        TargetValuePtr  AS LONG, _
        BufferLength    AS INTEGER, _
        StrLen          AS LONG) _
                        AS SHORT
'deflng crap = loadlibrary("ODBCCP32.DLL"): Showmessage str$(crap)
DECLARE FUNCTION SQLConfigDataSource _
        Lib "ODBCCP32.DLL" _
        Alias "SQLConfigDataSource" _
       (hwndParent     AS LONG, _
        fRequest       AS LONG, _
        lpszDriver     AS long, _
        lpszAttributes AS long) _
                       AS LONG
'         byRef lpszDriver     AS STRING, _
'         byRef lpszAttributes AS STRING) _
'                        AS LONG

DECLARE FUNCTION SQLCloseCursor _
        Lib "odbc32.dll" _
        Alias "SQLCloseCursor" _
       (StatementHandle AS LONG) _    ' hSTMT
                        AS SHORT

DECLARE FUNCTION SQLDescribeCol _
        Lib "odbc32.dll" _
        Alias "SQLDescribeCol" _
       (StatementHandle  AS LONG, _
        ColumnNumber     AS INTEGER, _
        ColumnName       AS LONG, _
        BufferLength     AS INTEGER, _
        NameLengthPtr    AS LONG, _
        DataTypePtr      AS LONG, _
        ColumnSizePtr    AS LONG, _
        DecimalDigitsPtr AS LONG, _
        NullablePtr      AS LONG) _
                         AS SHORT

DECLARE FUNCTION SQLDisconnect _
        Lib "odbc32.dll" _
        Alias "SQLDisconnect" _
       (ConnectionHandle AS LONG) _   ' hDBC
                         AS SHORT

DECLARE FUNCTION SQLDrivers _
        Lib "odbc32.dll" _
        Alias "SQLDrivers" _
       (EnvironmentHandle AS LONG, _    ' hEnv
        Direction         AS INTEGER, _
        DriverDescription AS LONG, _
        BufferLength1     AS INTEGER, _
        DescriptionLength AS INTEGER, _
        DriverAttributes  AS LONG, _
        BufferLength2     AS INTEGER, _
        AttributesLength  AS INTEGER) _
		                    AS SHORT

DECLARE FUNCTION SQLDriverConnect _
        Lib "odbc32.dll" _
        Alias "SQLDriverConnect" _
       (ConnectionHandle    AS LONG, _    ' hDBC
        WindowHandle        AS LONG, _
        InConnectionString  AS LONG, _
        StringLength1       AS INTEGER, _
        OutConnectionString AS LONG, _
        BufferLength        AS INTEGER, _
        StringLength2       AS LONG, _
        DriverCompletion    AS INTEGER) _
                            AS SHORT

DECLARE FUNCTION SQLError _
        Lib "odbc32.dll" _
        Alias "SQLError" _
       (ByVal env      AS LONG, _
        ByVal ldbc     AS LONG, _
        ByVal lStmt    AS LONG, _
        ByVal SQLState AS LONG, _
        NativeError    AS LONG, _
        ByVal Buffer   AS LONG, _
        ByVal BufLen   AS INTEGER, _
        OutLen         AS INTEGER) _
                       AS SHORT

DECLARE FUNCTION SQLExecDirect _
        Lib "odbc32.dll" _
        Alias "SQLExecDirect" _
       (StatementHandle AS LONG, _
        szSqlStr        AS LONG, _
        cbSqlStr        AS LONG) _
                        AS SHORT

DECLARE FUNCTION SQLFetch _
        Lib "odbc32.dll" _
        Alias "SQLFetch" _
       (StatementHandle AS LONG) _  ' hSTMT
                        AS SHORT

DECLARE FUNCTION SQLFetchScroll _
        Lib "odbc32.dll" _
        Alias "SQLFetchScroll" _
       (StatementHandle AS LONG, _
        FetchOrientation AS INTEGER, _
        FetchOffset AS LONG) _
        AS SHORT

DECLARE FUNCTION SQLFreeHandle _
        Lib "odbc32.dll" _
        Alias "SQLFreeHandle" _
       (HandleType AS INTEGER, _
        Handle     AS LONG) _
                   AS SHORT

DECLARE FUNCTION SQLGetData _
        Lib "odbc32.dll" _
        Alias "SQLGetData" _
       (StatementHandle AS LONG, _
        ColumnNumber    AS INTEGER, _
        TargetType      AS INTEGER, _
        TargetValue     AS LONG, _
        BufferLength    AS LONG, _
        StrLen          AS LONG) _
                        AS SHORT

DECLARE FUNCTION SQLNumResultCols _
        Lib "odbc32.dll" _
        Alias "SQLNumResultCols" _
       (StatementHandle   AS LONG, _
        NumCols           AS LONG) _
                          AS SHORT

DECLARE FUNCTION SQLSetConnectAttr _
        Lib "odbc32.dll" _
        Alias "SQLSetConnectAttr" _
       (ConnectionHandle AS LONG, _
        Attribute        AS INTEGER, _
        Value            AS INTEGER, _
        StringLength     AS INTEGER) _
                         AS SHORT

DECLARE FUNCTION SQLSetEnvAttr _
        Lib "odbc32.dll" _
        Alias "SQLSetEnvAttr" _
       (EnvironmentHandle AS LONG, _
        Attribute         AS INTEGER, _
        ValuePtr          AS INTEGER, _
        StringLength      AS INTEGER) _
                          AS SHORT

DECLARE FUNCTION SQLSetStmtAttr _
        Lib "odbc32.dll" _
        Alias "SQLSetStmtAttr" _
       (StatementHandlen AS LONG, _
        Attribute        AS INTEGER, _
        ValuePtr         AS INTEGER, _
        StringLength     AS INTEGER) _
                         AS SHORT

DECLARE FUNCTION SQLSetPos _
        Lib "odbc32.dll" _
        Alias "SQLSetPos" _
       (StatementHandlen AS LONG, _
        RowNumber        AS LONG, _
        Operation        AS INTEGER, _
        LockType         AS INTEGER) _
                         AS SHORT

DECLARE FUNCTION SQLTables _
        Lib "odbc32.dll" _
        Alias "SQLTables" _
       (StatementHandle AS LONG, _
        CatalogName     AS LONG, _
        NameLength1     AS INTEGER, _
        SchemaName      AS LONG, _
        NameLength2     AS INTEGER, _
        TableName       AS LONG, _
        NameLength3     AS INTEGER, _
        TableType       AS LONG, _
        NameLength4     AS INTEGER) _
                        AS SHORT

' ======================================
' =       New Object qDatabase:        =
' ======================================

DIM RetCode AS INTEGER
DIM ENV     AS LONG
DIM DBC     AS LONG

TYPE qDataBase EXTENDS qObject

   hENV  AS LONG
   hDBC  AS LONG
   hSTMT AS LONG

   sCon       AS STRING
   TableCount AS INTEGER
   Table(50)  AS STRING

   CONSTRUCTOR
      sCon = "DRIVER={Microsoft Access Driver (*.mdb)};PWD=;UID=;DBQ="
   END CONSTRUCTOR

' ----------------------------------------------------
   SUB CreateDatabase(db AS STRING)
   DIM Report AS STRING

      ' Si no trae la ruta, le agrega la del .EXE (quitando antes el EXE)
      IF INSTR(db, ":") = False THEN db = COMMAND$(0) - Application.ExeName & db

      IF FILEEXISTS(db) = True THEN
         ShowMessage "Ya existe " & db : EXIT SUB
      END IF
      db = db & CHR$(0) ' Importante para la function
    defstr arg1 = "Microsoft Access Driver"' (*.mdb)" + chr$(0) + chr$(0)
    defstr arg2 = "CREATE_DB= " + db+ chr$(0) + chr$(0)

'       retCode = SQLConfigDataSource( _
'                 SQL_NULL_HANDLE, _
'                 ODBC_ADD_DSN, _
'                 "Microsoft Access Driver (*.mdb)", _
'                 "CREATE_DB=" & db)

      retCode = SQLConfigDataSource( _
                SQL_NULL_HANDLE, _
                ODBC_ADD_DSN, _
                varptr(arg1), varptr(arg2))

      Report = IIF(retCode = False, "Error al crear ", "Se ha creado ")
      ShowMessage  Report & db

   END SUB

' ----------------------------------------------------
   SUB ConnectODBC()
    ' ..............................................................
    ' Pass 1 - Allocate environment handle
      retCode = SQLAllocHandle( _
                SQL_HANDLE_ENV, _
                SQL_NULL_HANDLE, _
                VARPTR(this.hENV))
      IF retCode = SQL_ERROR THEN
         ShowMessage "Error allocating environment handle" : EXIT SUB
      ELSE
         ENV = this.hENV
      END IF

    ' ..............................................................
    ' Pass 2 - Set the ODBC version environment attribute
      retCode = SQLSetEnvAttr( _
                this.hENV, _
                SQL_ATTR_ODBC_VERSION, _
                SQL_OV_ODBC3, _
                0)
      IF retCode = SQL_ERROR THEN
         ShowMessage "Error ODBC version" : EXIT SUB
      END IF

    ' ..............................................................
    ' Pass 3 - Allocate connection handle
      retCode = SQLAllocHandle( _
                SQL_HANDLE_DBC, _
                this.hENV, _
                VARPTR(this.hDBC))
      IF retCode = SQL_ERROR THEN
         ShowMessage "Error allocating connection handle" : EXIT SUB
      ELSE
         DBC = this.hDBC
      END IF

   END SUB
' ----------------------------------------------------
   SUB OpenDatabase(db AS STRING)

      ' Si no trae la ruta, le agrega la del .EXE (quitando antes el EXE)
      IF INSTR(db, ":") = False THEN db = COMMAND$(0) - Application.ExeName & db

      IF FILEEXISTS(db) = False THEN
         ShowMessage "No existe " & db : EXIT SUB
      END IF
      
    ' ..............................................................      
    ' Pass 1, 2, 3
	   this.ConnectODBC

    ' ..............................................................
    ' Pass 4 - Connect to driver
      DIM sResult AS STRING * 256
      DIM iSize   AS INTEGER

      this.sCon = this.sCon & db & ";"

      retCode = SQLDriverConnect( _
                this.hDBC, _
                0&, _
                VARPTR(this.sCon), _
                LEN(this.sCon), _
                VARPTR(sResult), _
                MAX_DATA_BUFFER, _
                VARPTR(iSize), _
                1)
      IF retCode = SQL_ERROR THEN
         ShowMessage "Error connecting to driver" : EXIT SUB
      END IF

    ' ..............................................................
    ' Pass 5 - Allocate statement handle
      retcode = SQLAllocHandle( _
                SQL_HANDLE_STMT, _
                this.hDBC, _
                VARPTR(this.hSTMT))
      IF retCode = SQL_ERROR THEN
         ShowMessage "Error allocating statement handle" : EXIT SUB
      END IF

   END SUB

' ----------------------------------------------------
   'SUB CloseDatabase
   SUB Close
      SQLFreeHandle(SQL_HANDLE_STMT, this.hSTMT)
      SQLDisconnect(this.hDBC)
      SQLFreeHandle(SQL_HANDLE_DBC, this.hDBC)
      SQLFreeHandle(SQL_HANDLE_ENV, this.hENV)
   END SUB

' ----------------------------------------------------
   SUB CreateTable(tbName AS STRING, tbStruct() AS STRING)
   DIM cQuery AS STRING, cItem AS STRING
   DIM i AS INTEGER, j AS INTEGER

      cQuery = "CREATE TABLE " & tbName & " ("

      FOR i = 1 TO UBOUND(tbStruct,1)
         FOR j = 1 TO UBOUND(tbStruct, 2)
            cItem = UCASE$(tbStruct(i, j))

            SELECT CASE j

               CASE 1    ' Nombre campo: si tiene espacios en blanco, poner entre corchetes
                  IF INSTR(cItem, " ") <> False THEN cItem = "[" & cItem & "]"

               CASE 2    ' Tipo de campo -> traducir a tipos Access
                  IF cItem = "CLAVE"  THEN cItem = "INTEGER PRIMARY KEY"
                  IF cItem = "TEXTO"  THEN cItem = "VARCHAR"
                  IF cItem = "MEMO"   THEN cItem = "LONGVARCHAR"   ' No funciona
                  IF cItem = "NUMERO" THEN cItem = ""
                  IF cItem = "FECHA"  THEN cItem = "TIMESTAMP"
                  IF cItem = "MONEDA" THEN cItem = "NUMERIC"
                  IF cItem = "SI/NO"  THEN cItem = "BIT"
                  IF cItem = "OBJETO" THEN cItem = "LONGVARBINARY" ' No funciona

               CASE 3    ' Subtipo campo en numericos, el ancho en texto, vacio en resto
                  IF cItem = "" THEN cItem = " "
                  IF cItem = "BYTE" THEN cItem = "TINYINT"
                  IF cItem = "ENTERO" THEN cItem = "SMALLINT"
                  IF cItem = "ENTERO LARGO" THEN cItem = "INTEGER"
                  IF cItem = "DOBLE" THEN cItem = "DOUBLE"
                  IF cItem = "SIMPLE" THEN cItem = "REAL"
                  IF IsNumeric(cItem) THEN cItem = "(" & cItem & ")"
                  cItem = RTRIM$(cItem) & ","

            END SELECT
            cQuery = cQuery & cItem & " "
         NEXT j
       NEXT i

      cQuery = REPLACE$(cQuery, ")", LEN(cQuery) - 1)
      retCode = SQLExecDirect(this.hSTMT, VARPTR(cQuery), LEN(cQuery))
      IF retCode <> SQL_SUCCESS THEN Error(this.hSTMT)
      retCode = SQLCloseCursor(this.hSTMT)

   END SUB

' ----------------------------------------------------
   SUB GetTables
    ' Adaptado del original ODBC.ini; revisar el codigo, parece muy farragoso
    ' Todo este paso no es necesario si no necesitamos guardar los nombres de las tablas
      DIM Catalog   AS STRING * 0
      DIM Schema    AS STRING * 0
      DIM TableName AS STRING * 0
      DIM TableType AS STRING * 5

      TableType="TABLE"
      retCode = SQLTables( _
                this.hSTMT, _
                VARPTR(Catalog),   0, _
                VARPTR(Schema),    0, _
                VARPTR(TableName), 0, _
                VARPTR(TableType), 5)

      IF retCode <> SQL_SUCCESS THEN
         ShowMessage "Could not get Tables!" : EXIT SUB
      END IF

      DIM iTable  AS INTEGER
      DIM tData   AS STRING * MAX_DATA_BUFFER
      DIM tOutLen AS LONG
      DIM iStatus AS INTEGER

      this.TableCount = 0
      DO
         retCode = SQLFetch(this.hSTMT)
         IF retCode <> SQL_SUCCESS THEN EXIT DO
         FOR iTable = 1 TO 3
            iStatus = SQLGetData(this.hSTMT, _
                      iTable, _
                      1, _
                      VARPTR(tData), _
                      MAX_DATA_BUFFER, _
                      VARPTR(tOutLen))
         NEXT
         this.TableCount++
         this.Table(this.TableCount) = Left$(tData, tOutlen)
      LOOP
   END SUB

END TYPE

' ======================================
' =       New Object qRecordSet:       =
' ======================================
TYPE qRecordSet EXTENDS qObject
   hSTMT              AS LONG
   tableSelect        AS STRING
   fieldCount         AS INTEGER
   fieldName(100)     AS STRING
   fieldTypeNum(100)  AS INTEGER
   fieldTypeName(100) AS STRING
   fieldSize(100)     AS INTEGER
'   FieldDec(100)      AS INTEGER ' Parece no funcionar
'   FieldNullav(100)   AS INTEGER ' Parece no funcionar
   idRec              AS LONG
   recordCount        AS LONG
   EOF                AS BOOLEAN
   BOF                AS BOOLEAN

' ----------------------------------------------------
   SUB OpenRecordset(RecordSet AS STRING)
   DIM cQuery AS STRING, nCols as LONG

      IF INSTR(RecordSet, " ") = 0 THEN  ' Es una tabla, no una consulta
         this.TableSelect = RecordSet
         cQuery = "SELECT * FROM " & RecordSet
      END IF

      retcode = SQLAllocHandle( _
                SQL_HANDLE_STMT, _
                DBC, _
                VARPTR(this.hSTMT))

      retCode = SQLSetStmtAttr( _
                this.hSTMT, _
                SQL_ATTR_CURSOR_TYPE, _
                SQL_CURSOR_KEYSET_DRIVEN, _
                0)

      retCode = SQLExecDirect(this.hSTMT, VARPTR(cQuery), LEN(cQuery))

      nCols = 0  ' Si no se inicializa a cero, nCols devuelve erroneo
      retCode = SQLNumResultCols(this.hSTMT, VARPTR(nCols))
      this.FieldCount = nCols

      DIM ColumnNumber  AS INTEGER
      DIM ColumnName    AS STRING * MAX_DATA_BUFFER
      DIM NameLength    AS INTEGER
      DIM DataType      AS INTEGER
      DIM NameType      AS STRING
      DIM ColumnSize    AS LONG
      DIM DecimalDigits AS INTEGER  ' Parece no funcionar
      DIM Nullable      AS INTEGER  ' Parece no funcionar

      FOR ColumnNumber = 1 TO nCols

         retCode = SQLDescribeCol(this.hSTMT, _
                                  ColumnNumber, _
                                  VARPTR(ColumnName), _
                                  MAX_DATA_BUFFER, _
                                  VARPTR(NameLength), _
                                  VARPTR(DataType), _
                                  VARPTR(ColumnSize), _
                                  VARPTR(DecimalDigits), _
                                  VARPTR(Nullable))
         this.FieldName(ColumnNumber) = LEFT$(ColumnName, NameLength)
         this.FieldSize(ColumnNumber) = ColumnSize
         this.FieldTypeNum(ColumnNumber) = DataType

'         this.FieldDec(ColumnNumber) = DecimalDigits
'         this.FieldNullav(ColumnNumber) = Nullable

         SELECT CASE DataType
            CASE 1     : NameType = "CHAR"
            CASE 2     : NameType = "NUMERIC"
            CASE 3     : NameType = "DECIMAL"
            CASE 4     : NameType = "INTEGER"
            CASE 5     : NameType = "SMALLINT"
            CASE 6     : NameType = "FLOAT"
            CASE 7     : NameType = "REAL"
            CASE 8     : NameType = "DOUBLE"
            CASE 9     : NameType = "DATE"
            CASE 10    : NameType = "TIME"
            CASE 93    : NameType = "TIMESTAMP"
            CASE 12    : NameType = "VARCHAR"
            CASE 65535 : NameType = "LONGVARCHAR"
            CASE 65534 : NameType = "BINARY"
            CASE 65533 : NameType = "VARBINARY"
            CASE 65532 : NameType = "LONGVARBINARY"
            CASE 65531 : NameType = "BIGINT"
            CASE 65530 : NameType = "TINYINT"
            CASE 65529 : NameType = "BIT"
            CASE 65456 : NameType = "TYPE_DRIVER_START"
            CASE ELSE  : NameType = "UNKNOWN TYPE"
         END SELECT
         this.FieldTypeName(ColumnNumber) = NameType
      NEXT ColumnNumber

      retCode = SQLCloseCursor(this.hSTMT)

      ' Pass 9 - Obtener numero de registros (rows)
      cQuery = "SELECT Count(*) AS Cuenta FROM " & this.TableSelect
      retCode = SQLExecDirect(this.hSTMT, VARPTR(cQuery), LEN(cQuery))
      retCode = SQLFetch(this.hSTMT)
      retCode = SQLGetData(this.hSTMT, 1, SQL_INTEGER, VARPTR(this.RecordCount), 0, 0)

      retCode = SQLFreeHandle(SQL_HANDLE_STMT, this.hSTMT)

   END SUB

' ----------------------------------------------------
   SUB GetData(ptrUDT AS LONG)
   DIM Cadena AS STRING, Entero AS INTEGER, Doble AS DOUBLE
   DIM iField AS INTEGER
   DIM xData AS STRING * MAX_DATA_BUFFER
   DIM tOutLen AS LONG
   DIM iStatus AS SHORT

      FOR iField = 1 TO this.FieldCount
         iStatus = SQLGetData(this.hSTMT, _
                              iField, _
                              SQL_CHAR, _
                              VARPTR(xData), _
                              MAX_DATA_BUFFER, _
                              VARPTR(tOutLen))

         Cadena = LEFT$(xData, tOutlen)

         SELECT CASE this.FieldTypeName(iField)
            CASE "VARCHAR"
               Cadena = Cadena & SPACE$(this.FieldSize(iField) - LEN(Cadena))
               MEMCPY(ptrUDT, VARPTR(Cadena), SIZEOF(Cadena))
               ptrUDT = ptrUDT + SIZEOF(Cadena)
            CASE "SMALLINT", "INTEGER"
               Entero = VAL(Cadena)
   ' ************ CHAPUZA *************'            
               IF UCASE$(this.FieldName(iField)) = "ID" THEN
                  this.IdRec = Entero
               END IF
					MEMCPY(ptrUDT, VARPTR(Entero), SIZEOF(Entero))
               ptrUDT = ptrUDT + SIZEOF(Entero)
            CASE "DOUBLE"
               Doble = VAL(Cadena)
               MEMCPY(ptrUDT, VARPTR(Doble), SIZEOF(Doble))
               ptrUDT = ptrUDT + SIZEOF(Doble)
         END SELECT

      NEXT iField

   END SUB

' ----------------------------------------------------
   SUB GetRecord(ptrUDT AS LONG)
   DIM cQuery AS STRING

      retcode = SQLAllocHandle( _
                SQL_HANDLE_STMT, _
                DBC, _
                VARPTR(this.hSTMT))

      retCode = SQLSetStmtAttr( _
                this.hSTMT, _
                SQL_ATTR_CURSOR_TYPE, _
                SQL_CURSOR_KEYSET_DRIVEN, _
                0)
 
      cQuery = "SELECT * FROM " & this.TableSelect

      retCode = SQLExecDirect(this.hSTMT, VARPTR(cQuery), LEN(cQuery))
      retCode = SQLFetch(this.hSTMT)
      this.GetData(ptrUDT)

   END SUB

' ---------------------------------------------------------
   SUB Add(ptrUDT AS LONG)
   DIM i AS INTEGER, cQuery AS STRING
   DIM Cadena AS STRING, Entero AS INTEGER, Doble AS DOUBLE

      cQuery = "INSERT INTO " & this.TableSelect & " VALUES("

      FOR i = 1 TO this.FieldCount
         SELECT CASE this.FieldTypeName(i)
            CASE "VARCHAR"
               Cadena = SPACE$(this.FieldSize(i))
               MEMCPY(VARPTR(Cadena), ptrUDT, SIZEOF(Cadena))
               cQuery = cQuery & CHR$(39) & RTRIM$(Cadena) & CHR$(39) & ", "
               ptrUDT = ptrUDT + SIZEOF(Cadena)
            CASE "SMALLINT"
               MEMCPY(VARPTR(Entero), ptrUDT, SIZEOF(Entero))
               cQuery = cQuery & STR$(Entero) & ", "
               ptrUDT = ptrUDT + 4
            CASE "DOUBLE"
               MEMCPY(VARPTR(Doble), ptrUDT, SIZEOF(Doble))
               cQuery = cQuery & STR$(Doble) & ", "
               ptrUDT = ptrUDT + 8
            CASE "INTEGER"
               IF UCASE$(this.FieldName(i)) = "ID" THEN
                  cQuery = cQuery & STR$(this.RecordCount + 1) & ", "
               END IF
         END SELECT
      NEXT i

      cQuery = LEFT$(cQuery, LEN(cQuery) - 2) & ")" ' Clear last comma+space
'showmessage cQuery
      retcode = SQLAllocHandle( _
                SQL_HANDLE_STMT, _
                DBC, _
                VARPTR(this.hSTMT))
'showmessage STR$(retcode)
      retCode = SQLExecDirect(this.hSTMT, VARPTR(cQuery), LEN(cQuery))
'showmessage STR$(retcode)
      IF retCode = SQL_SUCCESS THEN this.RecordCount++

      retCode = SQLFreeHandle(SQL_HANDLE_STMT, this.hSTMT)
'showmessage STR$(retcode)     
   END SUB

' ---------------------------------------------------------
   SUB Edit(ptrUDT AS LONG)
   DIM i AS INTEGER, cQuery AS STRING
   DIM Cadena AS STRING, Entero AS INTEGER, Doble AS DOUBLE
   DIM cItem AS STRING
   
      cQuery = "UPDATE " & this.TableSelect & " SET "

      FOR i = 1 TO this.FieldCount
         cItem = this.FieldName(i)
	      IF INSTR(cItem, " ") <> False THEN cItem = "[" & cItem & "]"
         SELECT CASE this.FieldTypeName(i)
            CASE "VARCHAR"
               Cadena = SPACE$(this.FieldSize(i))
               MEMCPY(VARPTR(Cadena), ptrUDT, SIZEOF(Cadena))
               cQuery = cQuery & cItem & "=" & CHR$(39) & RTRIM$(Cadena) & CHR$(39) & ", "
               ptrUDT = ptrUDT + SIZEOF(Cadena)
            CASE "SMALLINT"
               MEMCPY(VARPTR(Entero), ptrUDT, SIZEOF(Entero))
               cQuery = cQuery & cItem & "=" & STR$(Entero) & ", "
               ptrUDT = ptrUDT + 4
            CASE "DOUBLE"
               MEMCPY(VARPTR(Doble), ptrUDT, SIZEOF(Doble))
               cQuery = cQuery & cItem & "=" & STR$(Doble) & ", "
               ptrUDT = ptrUDT + 8
         END SELECT
      NEXT i

      cQuery = LEFT$(cQuery, LEN(cQuery) - 2) ' Clear last comma
      cQuery =  cQuery & " WHERE Id = " & STR$(this.IdRec)
    ' showmessage cQuery
      retcode = SQLAllocHandle( _
                SQL_HANDLE_STMT, _
                DBC, _
                VARPTR(this.hSTMT))

      retCode = SQLExecDirect(this.hSTMT, VARPTR(cQuery), LEN(cQuery))
      this.GetRecord(ptrUDT)

   END SUB

' ----------------------------------------------------
   SUB Del(ptrUDT AS LONG)
   DIM cQuery AS STRING

      retcode = SQLAllocHandle( _
                SQL_HANDLE_STMT, _
                DBC, _
                VARPTR(this.hSTMT))

	  cQuery = "DELETE FROM " & this.tableSelect & _
	         " WHERE Id = " & STR$(this.IdRec)  

      retCode = SQLExecDirect(this.hSTMT, VARPTR(cQuery), LEN(cQuery))
      
      IF retCode = SQL_SUCCESS THEN
         cQuery = "UPDATE " & this.tableSelect & _
                  " SET Id = Id - 1 WHERE Id > " & STR$(this.idRec)
         retCode = SQLExecDirect(this.hSTMT, VARPTR(cQuery), LEN(cQuery))
         this.idRec--
         this.recordCount-- 
      END IF   
      
   END SUB

' ----------------------------------------------------
   SUB moveNext(ptrUDT AS LONG)
      retCode = SQLFetchScroll(this.hSTMT, SQL_FETCH_NEXT, 0)
      IF retCode = SQL_NO_DATA THEN
         this.EOF = True : EXIT SUB
      END IF
      this.BOF = False 
      this.GetData(ptrUDT)
   END SUB

' ----------------------------------------------------
   SUB movePrevious(ptrUDT AS LONG)
      retCode = SQLFetchScroll(this.hSTMT, SQL_FETCH_PRIOR, 0)
      IF retCode = SQL_NO_DATA THEN
         this.BOF = True : EXIT SUB
      END IF
      this.EOF = False    
      this.GetData(ptrUDT)
   END SUB

' ----------------------------------------------------
   SUB moveLast(ptrUDT AS LONG)
      retCode = SQLFetchScroll(this.hSTMT, SQL_FETCH_LAST, 0)
      this.GetData(ptrUDT)
      this.EOF = True : this.BOF = False
   END SUB

' ----------------------------------------------------
   SUB moveFirst(ptrUDT AS LONG)
      retCode = SQLFetchScroll(this.hSTMT, SQL_FETCH_FIRST, 0)
      this.GetData(ptrUDT)
      this.BOF = True : this.EOF = False
   END SUB

' ----------------------------------------------------
   SUB moveTo(ptrUDT AS LONG, nRec AS LONG)
      retCode = SQLFetchScroll(this.hSTMT, SQL_FETCH_ABSOLUTE , nRec)
      this.GetData(ptrUDT)
   END SUB

' ----------------------------------------------------

END TYPE

' ----------------------------------------------------
FUNCTION IsNumeric(cText AS STRING) AS INTEGER
DIM i AS INTEGER, Sw AS INTEGER

   Sw = True
   FOR i = 1 TO LEN(cText)
      IF ASC(MID$(cText, i, 1 )) < 47 OR ASC(MID$(cText, i, 1 )) > 57 THEN Sw = False
   NEXT i

   IsNumeric = Sw

END FUNCTION

' ----------------------------------------------------
FUNCTIONI ptrUDT(...) AS LONG
   Result = paramVal(1)
END FUNCTIONI

' -----------------------------------------------------------------
SUB Error(STMT)
DIM lRet       AS SHORT
DIM sSQLState  AS STRING * MAX_DATA_BUFFER
DIM lErrNo     AS LONG
DIM sErrorMsg  AS STRING * MAX_DATA_BUFFER
DIM iLen       AS INTEGER
DIM sMsg       AS STRING
DIM From       AS STRING
DIM txtError   AS STRING

    lRet = SQLError(ENV, _
                    DBC, _
                    STMT, _
                    VARPTR(sSQLState), _
                    VARPTR(lErrNo), _
                    VARPTR(sErrorMsg), _
                    MAX_DATA_BUFFER, _
                    VARPTR(iLen))

    From = LEFT$(sErrorMsg, RINSTR(sErrorMsg, "]"))
    txtError = sErrorMsg - From

    sMsg = "Error Executing SQL Statement" & CHR$(13) _
         & "State: " & LTRIM$(LEFT$(sSQLState, INSTR(sSQLState, CHR$(0)) - 1)) & CHR$(13) _
         & "From: " & From & CHR$(13) _
         & "Error: " & txtError
    MessageBox(sMsg, "Error", 0)

END SUB
