'------------------------------------------------------------------------------------------'
'    Linear Solver R.1 26Feb04                                                             '
'    Solves System of Linear Equations and does Polynomial Regression                      '
'    By: puddlduk@yahoo.com                                                                '
'------------------------------------------------------------------------------------------'
'    R.2 20July06                                                                          '
'    - added regression for power, logarithmic and exponential formulas                    '
'    - fixed plot scaling bug                                                              '
'    - minimize to toolbar                                                                 ' 
'    - noted on plot that scaleX and scaleY aren't the same (plot is not to scale, it is   '
'      only meant to be a quick visual sanity check).                                      ' 
'------------------------------------------------------------------------------------------'
'    To do                                                                                 '
'    - add additional optimization (gradient seek?? or 'robust regression'??)              '
'    - add routine to identify matrix related data sets when loading from file;            '
'      load matrix + load coeff vs. load augmented matrix. Check matrix size and apply     '
'      to qstringgrid                                                                      '
'    - autosize matrix sgs on load (done for solve button)                                 '
'    - add datafile format note, recognize space delimited files, add simple instructions  '
'------------------------------------------------------------------------------------------'
'
$OPTION ICON "linear.ico"
$INCLUDE "RAPIDQ.INC" 
$TYPECHECK ON
'$OPTIMIZE ON
'$ESCAPECHARS ON

$RESOURCE types AS "types.bmp"
'
defint i,j,k,jmax,n,l,counter,pw,ph,sx,sy,s,test,mcounter
defdbl T,m,coeff,sm,v,xlow,ylow,xhigh,yhigh,scalex,scaley,x_plot,y_plot,py,xpoint,ypoint,x,y
defdbl syi,sxiyi,sxixiyi,syilnyi,sxiyilnyi,e,a,b 
defdbl slnxi,slnxilnxi,slnyi,slnxilnyi
defdbl syilnxi
defstr st,polystr,FileName,note
'
DIM OpenDialog AS QOpenDialog
DIM SaveDialog AS QSaveDialog
' 
declare sub MatrixSizeChange (Sender AS QEDIT)
declare sub Solve(Sender AS QBUTTON)
declare sub TabChange(sender as qtabcontrol)
declare sub FitCurve (sender as qbutton)
declare sub paint(sender as QCanvas)
declare sub LoadData (sender as Qbutton)
declare sub SaveData (sender as Qbutton)
declare sub ClearData (sender as Qbutton)
declare sub Resize (sender as Qform)
declare sub PolyEnter (Key AS WORD, Shift AS LONG, Sender AS QEDIT)
declare sub LoadMatrixFile (sender as Qbutton)
declare sub SaveMatrixFile (sender as Qbutton)
declare sub SaveCoefFile (sender as Qbutton)
declare sub LoadCoefFile (sender as Qbutton)
declare sub DummyProc
declare sub FitCurveExponential (sender as Qbutton)
declare sub FitCurvePower (sender as Qbutton)
declare sub FitCurveLogarithmic (sender as Qbutton)
declare sub FitCurvePolynomial (sender as Qbutton)
declare sub PlotData (sender as Qbutton)
declare sub HidePolyOrder (sender as Qbutton)
declare sub ShowPolyOrder (sender as Qbutton)
declare sub SolveData (sender as Qbutton)
'
