DIM P(80), Q(40), QO(40), S(1,80)
N = 20 : N2=2*N
S=12: D = .01 : G = .5: B = 3.5/20 : E = 1.5 : M=32
FOR x = -N2 TO N2
	P(N2+x) = 1-(1-G) * EXP(-10^(B*(x+E)))
	IF P(N2+x) >(1-D) THEN P(N2+x) = (1-D)
	S(0,N2-x) = LOGe(1-P(N2+x))
	S(1,N2-x) = LOGe(P(N2+x)
NEXT x
FOR T = -N TO N
	QO(N+T) = -(T/S)^2
	Q(N+T) = QO(N+T)
NEXT T
PRINT "prior estimate (+/-";s;"dB"; : INPUT PriorEst
PRINT "Actual threshold"; : input ActualThresh
FOR K = 1 TO M
	GOSUB CalcIt
	R = INT(P(N2 + X + PriorEst - ActualThresh) + RND(0)
	PRINT "Trial"; K; "at "; X + PriorEst; "dB has response "; R
	FOR T = -N to N
		Q(N+T) = Q(N+T) - QO(N+T)
	NEXT T
	GOSUB CalcIt
	PRINT "maximum likelihood estimate is "; X + PriorEst; "dB"
end

CalcIt:
	X = -N
	FOR T = -N TO N
		IF Q(N+T) > Q(N+X) THEN X = T
	NEXT T
RETURN
