'
$INCLUDE <QFtpClient.Inc>
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
'
Declare Sub OnClose_frmMyForm
Declare Sub OnClic_mnuDoFtp (Sender As QMenuItem)
'
Create frmMyForm As QForm
    Center
    Width = 600
    height = 800
    Caption = "frmMyForm V 1.0.0 " 
    AutoScroll = False
    OnClose = OnClose_frmMyForm
    CREATE rchWin AS QRichEdit  ' will disply the received datas
        Align = 5
        Font.Name = "courier"    
        Font.Size = 8
        Font.Color = &H800000
        Width = 200
        Height = 200
        ReadOnly = True
        WordWrap = False
        ScrollBars = ssBoth
        HideSelection = False 
        PlainText = True
    END CREATE
    CREATE Main AS QMAINMENU
        CREATE mnuDoFtp AS QMENUITEM
            Caption = "&DoFtp"
            OnClick = OnClic_mnuDoFtp
        END CREATE
    END CREATE
End Create
'
Dim myFTP As QFtpClient
'
' *************************************
frmMyForm.ShowModal
' *************************************
'
Sub OnClose_frmMyForm
    Application.Terminate
    End
End Sub
'
' ---------------- TEST CODE --------------------------------------------
'
Sub OnClic_mnuDoFtp (Sender)
    mnuDoFtp.Enabled = False
    Dim makeFile As QFileStream
    DefInt iTmp
    DefStr sTmp, sLine, sFrom, sTo
    ' Initialise
    If DirExists ("c:\\Tmp") = False Then MkDir "C:\\Tmp"
    makeFile.Open ("File_S0", fmCreate)
        makeFile.Write ("    \nThis is the original file test")
    makeFile.Close
    IF FileExists ("c:\\Tmp\\File_S4") Then Kill "c:\\Tmp\\File_S4"
    Sleep 2
    Doevents
    ' Start FTP
  With myFtp
    ' Connection
    rchWin.Addstring ("STEP 1")
    iTmp = .Connect ("homer.u.washington.edu", "jokelly", "asdfasdf")
    rchWin.Addstrings (.ErrorMsg)
    rchWin.Addstrings (.ReadMessage)

    ' Get Current Directory
    rchWin.Addstring ("STEP 2")
    rchWin.Addstrings ("      Current Directory : " & .GetDir)
    rchWin.Addstrings (.ErrorMsg)

    ' Upload a File
    rchWin.Addstring ("STEP 3")
    iTmp = .PutFile ("c:\\Tmp\\File_S0", "File_D1") 
    rchWin.Addstrings (.ErrorMsg)

    ' Set Directory
    rchWin.Addstring ("STEP 4")
    iTmp = .SetDir ("c:\\Tmp")
    rchWin.Addstrings (.ErrorMsg)

    ' Get Current Directory
    rchWin.Addstring ("STEP 5")
    rchWin.Addstrings ("      Current Directory : " & .GetDir)
    rchWin.Addstrings (.ErrorMsg)

    ' MakeDir (No Overwrite)
    rchWin.Addstring ("STEP 6")
    iTmp = .MakeDir ("newdir")
    rchWin.Addstrings (.ErrorMsg)

    ' Set Directory
    rchWin.Addstring ("STEP 7")
    iTmp = .SetDir ("newdir")
    rchWin.Addstrings (.ErrorMsg)

    ' Get Current Directory
    rchWin.Addstring ("STEP 8")
    rchWin.Addstrings (.ErrorMsg)
    rchWin.Addstrings ( "      Current Directory : " & .GetDir)

    ' Upload a File
    rchWin.Addstring ("STEP 9")
    sFrom ="c:\\Tmp\\File_S0"
    sTo =  "File_D2"
    iTmp = .PutFile (sFrom, sTo) 
    rchWin.Addstrings (.ErrorMsg)

    ' Rename a File (dont overwrite)
    rchWin.Addstring ("STEP 10")
    iTmp = .Rename ("File_D2", "File_D3")
    rchWin.Addstrings (.ErrorMsg)

    ' Delete a File
    rchWin.Addstring ("STEP 11")
    iTmp = .Delete ("File_D3")
    rchWin.Addstrings (.ErrorMsg)

    ' Set Directory 
    rchWin.Addstring ("STEP 12")
    iTmp = .SetDir ("c:\\Tmp")
    rchWin.Addstrings (.ErrorMsg)

    ' Remove Directory
    rchWin.Addstring ("STEP 13")
    iTmp = .RemoveDir ("newdir")
    rchWin.Addstrings (.ErrorMsg)

    ' Set Directory 
    rchWin.Addstring ("STEP 14")
    iTmp = .SetDir ("d:\\")
    rchWin.Addstrings (.ErrorMsg)

    ' Get Current Directory
    rchWin.Addstring ("STEP 15")
    rchWin.Addstrings ( "      Current Directory : " & .GetDir)
    rchWin.Addstrings (.ErrorMsg)

    ' DownLoad a File
    rchWin.Addstring ("STEP 16")
    iTmp = .GetFile ("FILE_D1", "c:\\Tmp\\FILE_S0", True) ' Overwrite
    rchWin.Addstrings (.ErrorMsg)

    ' DownLoad a File
    rchWin.Addstring ("STEP 17")
    sFrom = "FILE_D1"
    sTo = "c:\\Tmp\\FILE_S4"
    iTmp = .GetFile (sFrom, sTo, True)
    rchWin.Addstrings (.ErrorMsg)

    ' Delete A File
    rchWin.Addstring ("STEP 18")
    iTmp = .Delete ("d:\\FILE_D1")
    rchWin.Addstrings (.ErrorMsg)

    'Goto NOFILELIST
    Dim fileOut As QFileStream
    fileout.Open ("filelist.txt", fmCreate)
        sTmp = .FindFirstFile("c:\\Tmp\\*.*")
        iTmp = 1
        While sTmp <> ""
            sLine = Str$(iTmp) & "_th = " & sTmp & _
                    "\n     dosFileName = " & .dosFileName & _
                    "\n            size = " & Str$(.fileSize) &  _
                    "\n          DateUS = " & .fileDate &  _
                    "\n          DateEU = " & .FileDateEU &  _
                    "\n          TimeMs = " & .FileTimeMs &  _
                    "\n            Time = " & .FileTime & _
                    "\n        DateTime = " & Str$(.FileDateTime) & _
                    "\n      Attributes = " & Str$(.fileAttributes) & _
                    "\n   AttribAString = " & .fileAttributesAsString
            rchWin.Addstrings (sLine)
            fileOut.WriteLine (sLine)
            Inc iTmp
            sTmp = .FindNextFile
        Wend    
        rchWin.Addstrings ("End of directory")
        fileOut.WriteLine ("End of directory")
    fileOut.Close
    ' Check read only
    rchWin.Addstrings ("myFtpHandle=" & Str$(.ftpHandle))
NOFILELIST:
    ' Deconnection
    iTmp = .Close    ' Dont Forget To Close
    rchWin.Addstrings (.ErrorMsg)
    rchWin.Addstring ("   ***  I  AM  FINISHED  ***")
  End With
  mnuDoFtp.Enabled = True
End Sub
'
