'//////////////////////////////////////////////////////////
'//
'// Project Name : CLSID 2 IID Converter
'// Version      : 1.04.2006.25
'// Author       : Don67geo@Yahoo.com
'// Date         : April 25th, 2006
'//
'//////////////////////////////////////////////////////////
$typecheck ON

'test string:
' {CLSID:7BF80980-BF32-101A-8BBB-00AA00300CAB}
declare sub convertCLSID (key as short, shift as short)

create f as qform
    borderstyle = 1
    delbordericons 2
    caption = "CLSID to IID Converter Don"
    center
    create e as qedit
        text = "input CLSID and press ENTER"
        top = 10
        left = 10
        width = f.clientwidth-20
        onkeydown = convertCLSID
    end create
    create r as qrichedit
        top = 40
        left = 10
        width = f.clientwidth-20
        height = f.clientheight-(r.top + 10)
        font.name = "Courier"
        readonly = 1
        plaintext = 1
    end create
    showmodal
end create
end

sub convertCLSID (key as short, shift as short)
    if key=13 then
        defstr iid = e.text
        r.clear
        e.enabled = 0

        'some initial clean-up
        if INSTR(iid," ") then _
           iid = REPLACESUBSTR$(iid," ","")
        if INSTR(iid,"{") then _
           iid = REPLACESUBSTR$(iid,"{","")
        if INSTR(iid,"{") then _
           iid = REPLACESUBSTR$(iid,"}","")
        if INSTR(iid,":") then _
           iid = REPLACESUBSTR$(iid,":","")
        if INSTR(UCASE$(iid),"CLSID") then _
           iid = REPLACESUBSTR$(UCASE$(iid),"CLSID","")
        if INSTR(iid,"-") then _
           iid = REPLACESUBSTR$(iid,"-","")

        'character pos:
        '12345678-9012-3456-7890-123456789012
        '          1           2          3
        '7BF80980_BF32_101A_8BBB_00AA00300CAB
        r.text = "DEFINT IID_Result (0 TO 3) = _" + _
                 CHR$(13) + CHR$(10) + _
                 "    { _" + CHR$(13) + CHR$(10) +  _
                 "      &H" + MID$(iid,1,8) + _
                 ", _" + CHR$(13) + CHR$(10) +  _
                 "      &H" + MID$(iid,13,4) + _
                              MID$(iid,9,4) + _
                 ", _" + CHR$(13) + CHR$(10) +  _
                 "      &H" + MID$(iid,23,2) + _
                              MID$(iid,21,2) + _
                              MID$(iid,19,2) + _
                              MID$(iid,17,2) + _
                 ", _" + CHR$(13) + CHR$(10) +  _
                 "      &H" + MID$(iid,31,2) + _
                              MID$(iid,29,2) + _
                              MID$(iid,27,2) + _
                              MID$(iid,25,2) + _
                 "  _" + CHR$(13) + CHR$(10) +  _
                 "    }"
        e.enabled = 1
    end if
end sub

