$Include "Rapidq.inc"
$Include "QGrid.inc"
 
Declare Sub StyleClick(Sender as QRadioButton)
Declare Sub UnitClick(Sender as QRadioButton)
Declare Sub ColorClick(Sender as QRadioButton)
Create MainForm as QForm
      Caption = "MainForm"
      Top     = 131
      Left    = 217
      Width   = 588
      Height  = 365
End Create
Create Grid as QGrid
      Parent  = MainForm
      Top     = 16
      Left    = 16
      Width   = 425
      Height  = 297
End Create
Create sDots as QRadioButton
      Parent  = MainForm
      Top     = 24
      Left    = 456
      Width   = 73
      Height  = 17
      Caption = "gsDots"
      OnClick = StyleClick
      Tag     = 1
      Checked = True
End Create
Create sLine as QRadioButton
      Parent  = MainForm
      Top     = 48
      Left    = 456
      Width   = 73
      Height  = 17
      Caption = "gsLines"
      OnClick = StyleClick
      Tag     = 2
End Create
Create sMark as QRadioButton
      Parent  = MainForm
      Top     = 72
      Left    = 456
      Width   = 73
      Height  = 17
      Caption = "gsMark"
      OnClick = StyleClick
      Tag     = 3
End Create
Create GroupBoxU as QGroupBox
      Parent  = MainForm
      Top     = 104
      Left    = 456
      Width   = 113
      Height  = 57
      Caption = "Units"
      Color   = &HD8E9EC
End Create
Create rcMM as QRadioButton
      Parent  = GroupBoxU
      Top     = 16
      Left    = 16
      Width   = 57
      Height  = 17
      Caption = "MM"
      Checked = True
      OnClick = UnitClick
      Tag     = 1
End Create
Create rgINCH as QRadioButton
      Parent  = GroupBoxU
      Top     = 32
      Left    = 16
      Width   = 57
      Height  = 17
      Caption = "INCH"
      OnClick = UnitClick
      Tag     = 2
End Create
Create GroupBoxGC as QGroupBox
      Parent  = MainForm
      Top     = 168
      Left    = 456
      Width   = 113
      Height  = 121
      Caption = "GridColor"
      Color   = &HD8E9EC
End Create
Create rgRed as QRadioButton
      Parent  = GroupBoxGC
      Top     = 16
      Left    = 8
      Width   = 73
      Height  = 17
      Caption = "Red"
      OnClick = ColorClick
      Tag     = 255
End Create
Create rgBlue as QRadioButton
      Parent  = GroupBoxGC
      Top     = 40
      Left    = 8
      Width   = 81
      Height  = 17
      Caption = "Blue"
      OnClick = ColorClick
      Tag     = &HFF0000
End Create
Create rgGray as QRadioButton
      Parent  = GroupBoxGC
      Top     = 64
      Left    = 8
      Width   = 73
      Height  = 17
      Caption = "Gray"
      OnClick = ColorClick
      Tag     = &HC0C0C0
End Create
Create rgBlack as QRadioButton
      Parent  = GroupBoxGC
      Top     = 88
      Left    = 8
      Width   = 81
      Height  = 17
      Caption = "Black"
      OnClick = ColorClick
      Tag     = 0
      Checked = True
End Create
$Include "Minimize.inc"

SetMinimize(MainForm)
MainForm.ShowModal

Sub StyleClick(Sender as QRadioButton)
Grid.GridStyle = Sender.Tag
End Sub
 
Sub UnitClick(Sender as QRadioButton)
Grid.Units = Sender.Tag
If Grid.Units = 1 then
   Grid.StepX  = 2.54
   Grid.StepY  = 2.54
ElseIf Grid.Units = 2 then
   Grid.StepX  = 0.05
   Grid.StepY  = 0.05
End If
End Sub

Sub ColorClick(Sender as QRadioButton)
Grid.GridColor = Sender.Tag
End Sub
