'------------------------------------------------------------
' CREER ET DETRUIRE UN COMPOSANT QTABCONTROL
'------------------------------------------------------------
' Ce code repose en grande partie sur le code de OnionX et David
' Je l'ai simplement adapter pour le QTABControl 
' car il est particulier
'
' J'ai ensuite ajout la gestion des options compatibles
' DGNOYON
'------------------------------------------------------------

$TYPECHECK ON
$Include "RapidQ.inc"

Declare Function DestroyWindow Lib "user32" Alias "DestroyWindow" (ByVal hWnd As Long) As Long
Declare Function GetParent Lib "user32" Alias "GetParent" (hWnd As Long) As Long

Declare Sub CreateComponent
Declare Sub DestroyComponent
Declare sub ChangeRadio (sender as QRadioButton)
Declare sub ChangeCheck (sender as QCheckBox)

DefInt ComponentCount
DefLng hWnd_For_DestroyWindow

Create MainForm As QForm
    Caption = "Create & Destroy a Component"
    Width = 340
    Height = 320
    Center
    OnShow  = CreateComponent
    Create Group1 As QGroupBox
        Left = 10
        Top = 10
        Width = 150
        Height = 80
        Create radio0 as QRadioButton
            Top = 10
            Left = 10
            Caption = "Normal"
            Tag = 0
            Checked = 1
            OnClick = ChangeRadio
        End create
        Create radio1 as QRadioButton
            Top = 27
            Left = 10
            Caption = "VerticalTabs"
            Tag = 1
            OnClick = ChangeRadio
        End create
        Create radio2 as QRadioButton
            Top = 45
            Left = 10
            Caption = "ButtonTabs"
            Tag = 2
            OnClick = ChangeRadio
        End create
    End Create
    Create Group2 As QGroupBox
        Left = 170
        Top = 10
        Width = 150
        Height = 120   
        Create Check1 as QCheckbox
            Top = 10
            Left = 10
            Caption = "HotTrack"
            tag = 40
            OnClick = ChangeCheck
        End Create
        Create Check2 as QCheckbox
            Top = 27
            Left = 10
            Caption = "ScrollOpposite"
            Tag = 41
            OnClick = ChangeCheck
        End Create
        Create Check3 as QCheckbox
            Top = 44
            Left = 10
            Caption = "MultiLine"
            tag = 42
            OnClick = ChangeCheck
        End Create
        Create Check4 as QCheckbox
            Top = 61
            Left = 10
            Caption = "FlatButtons"
            tag = 43
            Enabled = 0
            OnClick = ChangeCheck
        End Create
        Create Check5 as QCheckbox
            Top = 78
            Left = 10
            Caption = "FlatSeperators"
            tag = 44
            Enabled = 0
            OnClick = ChangeCheck
        End Create
        Create Check6 as QCheckbox
            Top = 95
            Left = 10
            Caption = "FocusButtons"
            tag = 45
            Enabled = 0
            OnClick = ChangeCheck
        End Create
    End Create
    Create HwndControl as QEDIT 'Ce composant sert  obtenir le Handle du TabControl 
        Left = 50
        Top = 50
        Visible = 0
    End create
End Create

' Cration d'un Array de Tab
Dim Tab(0) As Qtabcontrol
    tab(0).Parent = MainForm
    tab(0).Left = 10
    tab(0).Top = 135
    tab(0).Width = 310
    tab(0).Height = 130
    Tab(0).tag = 0
    
Sub ChangeRadio (sender as QRadioButton)
    DestroyComponent
    CreateComponent
    IF sender.tag = 1 THEN 
        Tab(ComponentCount).VerticalTabs = 1
        Tab(ComponentCount).ButtonStyle = 0
        Check1.Enabled = 1
        Check2.Enabled = 1
        Check3.Enabled = 0
        Check4.Enabled = 0
        Check5.Enabled = 0
        check6.Enabled = 0
    ELSEIF sender.tag = 2 THEN
        Tab(ComponentCount).VerticalTabs = 0
        Tab(ComponentCount).ButtonStyle = 1
        Check1.Enabled = 1
        Check2.Enabled = 0
        Check3.Enabled = 1
        Check4.Enabled = 1
        Check5.Enabled = 1
        check6.Enabled = 1
    ELSE
        Tab(ComponentCount).VerticalTabs = 0
        Tab(ComponentCount).ButtonStyle = 0
        Check1.Enabled = 1
        Check2.Enabled = 1
        Check3.Enabled = 1
        Check4.Enabled = 0
        Check5.Enabled = 0
        check6.Enabled = 0
    END IF
END SUB

Sub ChangeCheck (sender as QCheckBox)
    ' Options actives
    IF sender.tag = 40 AND Sender.Checked = 1 THEN Tab(ComponentCount).HotTrack = 1
    IF sender.tag = 41 AND Sender.Checked = 1 THEN Tab(ComponentCount).Scrollopposite = 1 : Check3.Enabled = 0 
    IF sender.tag = 42 AND Sender.Checked = 1 THEN Tab(ComponentCount).MultiLine = 1 : Check2.Checked = 0
    IF sender.tag = 43 AND Sender.Checked = 1 THEN Tab(ComponentCount).FlatButtons = 1
    IF sender.tag = 44 AND Sender.Checked = 1 THEN Tab(ComponentCount).FlatSeperators = 1
    IF sender.tag = 45 AND Sender.Checked = 1 THEN Tab(ComponentCount).FocusButtons = 1
    ' Options inactives    
    IF sender.tag = 40 AND Sender.Checked = 0 THEN Tab(ComponentCount).HotTrack = 0
    IF sender.tag = 41 AND Sender.Checked = 0 THEN Tab(ComponentCount).Scrollopposite = 0 : Tab(ComponentCount).MultiLine = 0 : Check3.Enabled = 1 : Check3.Checked = 0
    IF sender.tag = 42 AND Sender.Checked = 0 THEN Tab(ComponentCount).MultiLine = 0 : Check2.Enabled = 1 : Check3.Checked = 0

    IF sender.tag = 43 AND Sender.Checked = 0 THEN Tab(ComponentCount).FlatButtons = 0
    IF sender.tag = 44 AND Sender.Checked = 0 THEN Tab(ComponentCount).FlatSeperators = 0
    IF sender.tag = 45 AND Sender.Checked = 0 THEN Tab(ComponentCount).FocusButtons = 0
END SUB

Sub CreateComponent
    Tab(0).tag = Tab(0).Tag + 1
    HwndControl.parent = Tab(0)
    hWnd_For_DestroyWindow = GetParent (HwndControl.handle)
    
    INC(ComponentCount)
    ReDim Tab(ComponentCount) As QTABControl
    
    Tab(ComponentCount).Parent = MainForm
    Tab(ComponentCount).Left = 10
    Tab(ComponentCount).Top = 135
    Tab(ComponentCount).Width = 310
    Tab(ComponentCount).Height = 130
    Tab(ComponentCount).Addtabs "1","2","3","4","5","6","7","8","9"
    Tab(ComponentCount).ScrollOpposite = 0
    Tab(ComponentCount).ButtonStyle = 0
    Tab(ComponentCount).HotTrack = 0
    Tab(ComponentCount).MultiLine = 0
    Tab(ComponentCount).ScrollOpposite = 0
    Tab(ComponentCount).VerticalTabs = 0
    Tab(ComponentCount).FlatButtons = 0
    Tab(ComponentCount).FlatSeperators = 0
    Tab(ComponentCount).visible = 1
        
    HwndControl.parent = Tab(ComponentCount)
    hWnd_For_DestroyWindow = GetParent(HwndControl.handle)
End Sub

Sub DestroyComponent
    Dim i as integer
    Check1.Checked = 0
    Check2.Checked = 0
    Check3.Checked = 0
    Check4.Checked = 0
    Check5.Checked = 0
    Check6.Checked = 0    
    Tab(ComponentCount).Visible = False
    For i = 0 to 8
        tab(0).Deltabs (Tab(0).TabIndex)
    next
    DestroyWindow(hWnd_For_DestroyWindow)
End Sub
MainForm.ShowModal
