'
' Test Rebar (with QToolBarEX)
' Rebar - Not all functionality used (or understood)
'
' Toolbars put into QPANEL containers to fix the width initially.
' The rebar component can then resize them after that.
'
' Author: d_homans@yahoo.com.au
' Date:   25 Mar 2011
'
$APPTYPE GUI
$TYPECHECK ON

$INCLUDE <Rapidq2.inc>
$INCLUDE "ReBar.inc"
$INCLUDE "QToolBarEX.inc"

CONST VERS="v0.2"

DECLARE SUB ShowMe1(Index AS integer)
DECLARE SUB ShowMe2(Index AS integer)
DECLARE SUB ShowMe3(Index AS integer)
DECLARE SUB Done

CREATE Form1 AS QFORM
    Width = 800
    Height = 400
    Caption = "ReBar Test "+VERS
    Center
    CREATE pan1 AS QPANEL                                       ' Container for toolbar
        Width=8*(29+2)                                          ' 8 btns x (29 pix + 2 pix border)
        Height=32                                               ' Btn height + 2 pix
        CREATE Bar1 AS QToolBarEX
            BtnCount=8
            BMP="ToolBarA.bmp"
            OnSelect=ShowMe1
        END CREATE
    END CREATE
    CREATE pan2 AS QPANEL                                       ' Container for toolbar
        Width=248
        Height=32
        CREATE Bar2 AS QToolBarEX
            BtnCount=8
            BMP="ToolBarB.bmp"
            OnSelect=ShowMe2
        END CREATE
    END CREATE
    CREATE pan3 AS QPANEL                                       ' Container for toolbar
        Width=248
        Height=32
        CREATE Bar3 AS QToolBarEX
            BtnCount=8
            BMP="ToolBarC.bmp"
            OnSelect=ShowMe3
        END CREATE
    END CREATE
    CREATE Butn1 AS QBUTTON
        Left = (Form1.ClientWidth-Butn1.Width)\2
        Top = 300
        Caption = "EXIT"
        OnClick = Done
    END CREATE
END CREATE

DEFLNG ReBarHwnd=InitReBar(Form1.Handle,Pan1.Handle,Pan2.Handle,Pan3.Handle)

IF ReBarHwnd=0 THEN Showmessage "Error #: "+STR$(ErrNum): END       ' WSAGetLastError??

SetWindowLong(Form1.Handle, GWL_HWNDPARENT, 0)
SetWindowLong(Application.Handle, GWL_HWNDPARENT, Form1.Handle)

Form1.ShowModal

SUB ShowMe1
ShowMessage "You clicked on ToolBar 1: Button #"+STR$(Index+1)
END SUB

SUB ShowMe2
ShowMessage "You clicked on ToolBar 2: Button #"+STR$(Index+1)
END SUB

SUB ShowMe3
ShowMessage "You clicked on ToolBar 3: Button #"+STR$(Index+1)
END SUB

SUB Done
Application.Terminate
END SUB

