'
' Some of the constants
'
' Ref:   http://msdn.microsoft.com/en-us/library/bb774375%28v=VS.85%29.aspx
'
$DEFINE CCS_NODIVIDER           &h40

$DEFINE RB_INSERTBAND           &h401

$DEFINE RBS_VARHEIGHT           &h200
$DEFINE RBS_BANDBORDERS         &h400

$DEFINE RBBS_BREAK              &h1
$DEFINE RBBS_FIXEDSIZE          &h2
$DEFINE RBBS_CHILDEDGE          &h4
$DEFINE RBBS_NOVERT             &h10
$DEFINE RBBS_FIXEDBMP           &h20
$DEFINE RBBS_GRIPPERALWAYS      &h80
$DEFINE RBBS_NOGRIPPER          &h100
$DEFINE RBBS_USECHEVRON         &h200
$DEFINE RBBS_HIDETITLE          &h400
$DEFINE RBBS_TOPALIGN           &h800

$DEFINE RBBIM_STYLE             &h1
$DEFINE RBBIM_TEXT              &h4
$DEFINE RBBIM_CHILD             &h10
$DEFINE RBBIM_CHILDSIZE         &h20
$DEFINE RBBIM_SIZE              &h40

$DEFINE ICC_LISTVIEW_CLASSES    &h1
$DEFINE ICC_TREEVIEW_CLASSES    &h2
$DEFINE ICC_BAR_CLASSES         &h4
$DEFINE ICC_TAB_CLASSES         &h8
$DEFINE ICC_UPDOWN_CLASS        &h10
$DEFINE ICC_PROGRESS_CLASS      &h20
$DEFINE ICC_HOTKEY_CLASS        &h40
$DEFINE ICC_ANIMATE_CLASS       &h80
$DEFINE ICC_WIN95_CLASSES       &hff
$DEFINE ICC_DATE_CLASSES        &h100
$DEFINE ICC_USEREX_CLASSES      &h200
$DEFINE ICC_COOL_CLASSES        &h400
'#if (_WIN32_IE >= 0x0400)
'$DEFINE INFOTIPSIZE 1024
$DEFINE ICC_INTERNET_CLASSES    &h800
$DEFINE ICC_PAGESCROLLER_CLASS  &h1000
$DEFINE ICC_NATIVEFNTCTL_CLASS  &h2000
'#endif /* _WIN32_IE */
'#if (_WIN32_WINNT >= 0x501)
$DEFINE ICC_STANDARD_CLASSES    &h4000
$DEFINE ICC_LINK_CLASS          &h8000
'#endif

$DEFINE WS_EX_TOOLWINDOW        &H80

TYPE REBARBANDINFO
    cbSize          AS long
    fMask           AS long
    fStyle          AS long
    clrFore         AS long
    clrBack         AS long
    lpText          AS long
    cch             AS long
    iImage          AS integer
    hwndChild       AS long
    cxMinChild      AS long
    cyMinChild      AS long
    cx              AS long
    hWndBmpBack     AS long
    wID             AS long
    cyChild         AS long
    cyMaxChild      AS long
    cyIntegral      AS long
    cxIdeal         AS long
    lParam          AS long
    cxHeader        AS long
'#if (_WIN32_WINNT >= 0x0600)
'  lprctChevronLocation AS long
'  uChevronState AS long
'#endif 
END TYPE 

TYPE INITCOMCNTRLEX
    dwSize          AS long
    dwICC           AS long
END TYPE

DECLARE FUNCTION InitCommonControlsEx LIB "Comctl32" ALIAS "InitCommonControlsEx" (lpInitCtrls AS long) AS integer

DEFINT ErrNum                                                               ' Global, not good!

' Add variable number of components
' NB If component doesn't have a handle, may have to put it into
' a container that does. The ToolBars are in containers only to
' fix widths initially, then the ReBar can play with them.
'
FUNCTIONI InitReBar(...) AS long
DIM icex AS INITCOMCNTRLEX
DIM rbBand AS REBARBANDINFO
DIM rc AS QRECT
DEFLNG hwndRebar
DEFINT i

    Result=0
    IF ParamValCount<2 THEN ErrNum=1: EXIT FUNCTIONI                        ' Rebar with no child components?

    icex.dwSize=SIZEOF(icex)
    icex.dwICC=ICC_STANDARD_CLASSES
    IF InitCommonControlsEx(icex)<>0 THEN ErrNum=2: EXIT FUNCTIONI

    hwndRebar=CreateWindowEx(WS_EX_TOOLWINDOW, "ReBarWindow32", 0, WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS _
                                OR WS_CLIPCHILDREN OR RBS_VARHEIGHT OR RBS_BANDBORDERS, _           'OR CCS_NODIVIDER
                                0,0,0,0, ParamVal(1), 0, Application.hInstance, 0)

    IF hwndRebar=0 THEN ErrNum=3: EXIT FUNCTIONI

    rbBand.cbSize=SIZEOF(rbBand)
    rbBand.fMask=RBBIM_STYLE OR RBBIM_CHILD OR RBBIM_CHILDSIZE OR RBBIM_SIZE                        ' OR RBBS_BREAK
    rbBand.fStyle=RBBS_CHILDEDGE OR RBBS_GRIPPERALWAYS 

    FOR i=2 TO ParamValCount
        rbBand.lpText=0
        rbBand.hwndChild=ParamVal(i)
        GetWindowRect(ParamVal(i), rc)
        rbBand.cxMinChild=rc.Right-rc.Left                                  ' Minimum width of band
        rbBand.cyMinChild=rc.Bottom-rc.Top                                  ' Minimum height of band
        rbBand.cx=rc.Right-rc.Left                                          ' Height of band...
        SendMessage(hwndRebar, RB_INSERTBAND, -1, rbBand)                   ' ..Width may depend on other flags used
    NEXT i

    Result=hwndRebar
END FUNCTIONI
