'
' MyToolBar Demo - QToolBarEX.inc - using ..EX as there are other toolbar codes around
'
$APPTYPE GUI
$TYPECHECK ON

$INCLUDE <Rapidq2.inc>

'$DEFINE MAXTOOLBTNS 32                                      ' Override define in QToolBarEX.inc???

$INCLUDE "QToolBarEX.inc"

$RESOURCE RNDButtons AS "ToolBar1.bmp"                      ' Crappy example
$RESOURCE SQRButtons AS "ToolBar2.bmp"                      ' more of same

CONST VER="v0.7"                                            ' A crappy demo as well!

'-----------------------------------------------------------------------------------
' Test ToolBar
'-----------------------------------------------------------------------------------
DECLARE SUB Initialise
DECLARE SUB ShowMe1(Index AS integer)
DECLARE SUB ShowMe2(Index AS integer)
DECLARE SUB Done

'
' NB My Test bitmap "strips" - images are w=35 h=24
' Transparency color is (automatically) the bottom left pixel
' Change ToolBar2 to Align=alTop, see result (or alLeft/alRight)
'
CREATE Form1 AS QFORM
    Caption = "Test ToolBar "+VER
    Width=350
    Center
    CREATE MyToolBar1 AS QToolBarEX
        Align=alTop                                                 ' ToolBar align to top (default)
'        Height=45                                                   ' ToolBar height (fixates image height!)
        BtnCount=8                                                  ' Button count
        BtnSpacer=2                                                 ' Space between buttons (def = 1)
        BMP="ToolBar1.bmp"                                          ' Load a bmp file
        Hint="One,Two,Three,Four,Five,Six,Seven,Eight"              ' Load hints for the 8 btns
        Cursor=crHandPoint
        OnSelect=ShowMe1                                            ' User clicks a btn
    END CREATE
    CREATE MyToolBar2 AS QToolBarEX
        Align=alBottom
'        Height=45                                                  ' ToolBar height - stretch vertically?
'        Visible=False
        BtnCount=8
        BMPHandle=1                                                 ' Load bmp resource(1)
        Hint="A,B,C,D,E,F,G,H"
        OnSelect=ShowMe2
    END CREATE
    CREATE Butn1 AS QBUTTON
        Left = (Form1.Width-Butn1.Width)\2
        Top = (Form1.ClientHeight-Butn1.Height)\2
        Caption = "EXIT"
        OnClick = Done
    END CREATE
END CREATE

SetWindowLong(Form1.Handle, GWL_HWNDPARENT, 0)
SetWindowLong(Application.Handle, GWL_HWNDPARENT, Form1.Handle)

Form1.ShowModal

' Index range 0 to BtnCount-1
SUB ShowMe1(Index)
showmessage "ToolBar #1: Button "+STR$(Index+1)
END SUB

SUB ShowMe2(Index)
showmessage "ToolBar #2: Button "+STR$(Index+1)
END SUB

SUB Done
Application.Terminate
END SUB

