$INCLUDE <RapidQ2.inc>
'$INCLUDE <XpGroupBox.inc>
$OPTION ICON "Raptor.ico"

$RESOURCE SRCBMP AS "WinFlag8.bmp"   ' 8 bit source bitmap with ChromaTransparency

DIM BMSrc AS QBITMAP
BMSrc.BMPHandle = SRCBMP
BMSrc.Transparent = True

' Background
DIM BkGrnd AS QBITMAP
BkGrnd.Width  = BMSrc.Width
BkGrnd.Height = BMSrc.Height
BkGrnd.FillRect(0, 0, BMSrc.Width, BMSrc.Height, clBtnFace)

' For results of alphablends
DIM BMRes1 AS QBitmapEx
DIM BMRes2 AS QBitmapEx
DIM BMRes3 AS QBitmapEx
DIM BMRes4 AS QBitmapEx
DIM BMRes5 AS QBitmapEx

' 25% AlphaBlend without Converted Transparency
BMRes1.BMP = BkGrnd.BMP
AlphaBlend(BMRes1.Handle, 0, 0, BMRes1.Width, BMRes1.Height, _
        BMSrc.Handle, 0, 0, BMSrc.Width, BMSrc.Height, &H00400000)

' 25% AlphaBlend with Converted Transparency
BMRes2.AlphaBlend(BkGrnd, BMSrc, -.25)

' 10% AlphaBlend with Converted Transparency
BMRes3.AlphaBlend(BkGrnd, BMSrc, -.1)

' 50% AlphaBlend with Converted Transparency
BMRes4.AlphaBlend(BkGrnd, BMSrc, -.5)

' 100% AlphaBlend with Converted Transparency
BMRes5.AlphaBlend(BkGrnd, BMSrc, -1)

CREATE Form AS QFORM
  Top    = 0
  Left   = 214
  Width  = 800
  Height = 570
  Caption = "ChromaTransparency to AlphaTransparency Conversion Test"
  CREATE GroupBox1 AS QGroupBox' XpGroupBox
    Top    = 10
    Left   = 10
    Width  = 250
    Height = 250
    Caption = "8 bit Original Raw"
    CREATE Image1 AS QIMAGE
      Top  = 20
      Left = 10    
      AutoSize = True
      BMP = BMSrc.BMP
    END CREATE
  END CREATE
  CREATE GroupBox2 AS QGroupBox' XpGroupBox
      Top    = 10
    Left   = 270
    Width  = 250
    Height = 250
    Caption = "25% Blend without Transparency Conversion"
    CREATE Image2 AS QIMAGE
      Top   = 20
      Left  = 10
      AutoSize = True
      BMP = BMRes1.BMP
    END CREATE
  END CREATE
  CREATE GroupBox3 AS QGroupBox' XpGroupBox
    Top    = 10
    Left   = 530
    Width  = 250
    Height = 250
    Caption = "25% AlphaBlend with Transparency Conversion"
    CREATE Image3 AS QIMAGE
      Top  = 20
      Left = 10 
      AutoSize = True
      BMP = BMRes2.BMP
    END CREATE
  END CREATE
  CREATE GroupBox4 AS QGroupBox' XpGroupBox
    Top    = 270
    Left   = 10
    Width  = 250
    Height = 250
    Caption = "10% AlphaBlend with Transparency Conversion"
    CREATE Image4 AS QIMAGE
      Top  = 20
      Left = 10    
      AutoSize = True
      BMP = BMRes3.BMP
    END CREATE
  END CREATE
  CREATE GroupBox5 AS QGroupBox' XpGroupBox
    Top    = 270
    Left   = 270
    Width  = 250
    Height = 250
    Caption = "50% AlphaBlend with Transparency Conversion"
    CREATE Image5 AS QIMAGE
      Top   = 20
      Left  = 10
      AutoSize = True
      BMP = BMRes4.BMP
    END CREATE
  END CREATE
  CREATE GroupBox6 AS QGroupBox' XpGroupBox
    Top    = 270
    Left   = 530
    Width  = 250
    Height = 250
    Caption = "100% AlphaBlend with Transparency Conversion"
    CREATE Image6 AS QIMAGE
      Top  = 20
      Left = 10 
      AutoSize = True
      BMP = BMRes5.BMP
    END CREATE
  END CREATE
  ShowModal
END CREATE
