$TYPECHECK ON


Declare Function GetDeviceGammaRamp Lib "gdi32.dll" ALIAS "GetDeviceGammaRamp" (ByVal hdc As Long, lpRamp AS LONG) AS LONG
Declare Function SetDeviceGammaRamp Lib "gdi32.dll" ALIAS "SetDeviceGammaRamp" (ByVal hdc As Long, lpRamp AS LONG) AS LONG
Declare Function GetDC Lib "user32" Alias "GetDC" (ByVal hwnd As Long) As Long
Declare Function GetWindowDC Lib "user32" Alias "GetWindowDC" (ByVal hwnd As Long) As Long
Declare Function ReleaseDC Lib "user32" Alias "ReleaseDC" (ByVal hwnd As Long, ByVal hdc As Long) As Long

DECLARE SUB ColorChange
DECLARE SUB Paint
DECLARE SUB GammaRamp

DIM RampX(0 TO 2, 0 To 255) AS WORD
DIM RampY(0 To 2, 0 To 255) AS WORD

Dim HRESULT		As LONG
Dim indx		As LONG
Dim MyHdc     	As long


CREATE Form AS QForm
    Width = 700
    Height = 600    
'	BorderStyle = 0
 	ONclick = GammaRamp
  CREATE PaintBox AS Qcanvas
    Left = 2
    Top = 12
    Height = 90
    Width = 255
    OnPaint = Paint
  END CREATE
  CREATE OutText AS QRICHEDIT
	left = 380
	top = 5
	Width = 300
	Height = 500
  END CREATE
  Caption = "GammaCorrection"
  Center
END CREATE


SUB Paint
  dim x as integer
  dim y as integer
  for x = 1 to 255
    PaintBox.Line (x, 0,x ,90,RGB(x,x,x))                       
   Next x                       
END SUB



Sub GammaRamp
   '----------------------------------------------------------------
dim x as integer
OutText.Clear
    For indx = 0 To 255
		x = &HFF00 - indx * &HFF
		RampY(0, indx) = RampX(0,indx)/2'x
		RampY(1, indx) = RampX(1,indx)/2'x
		RampY(2, indx) = RampX(2,indx)/2'x
		OutText.Text = OutText.Text + _
		hex$(RampY(0, indx)) + "  " + _
		hex$(RampY(1, indx)) + "  " + _
		hex$(RampY(2, indx)) + CHR$(13)+chr$(10)
    Next indx


ShowMessage "Get ready"
    DEFINT DC = GetDC(0)         'get destop device context
    HRESULT = SetDeviceGammaRamp(DC, VARPTR(RampY(0,0))) : ShowMessage "result = " +str$(HRESULT)
    ReleaseDC(0,DC)             'always release it
End Sub





MyHdc = GetDC(Form.Handle)
HRESULT = GetDeviceGammaRamp(MyHdc, VARPTR(RampX(0,0)))
ShowMessage str$(HRESULT)
ReleaseDC(Form.Handle, MyHdc)

OutText.Clear
For indx = 0 To 255
	OutText.Text = OutText.Text + _
	hex$(RampX(0, indx)) + "  " + _
	hex$(RampX(1, indx)) + "  " + _
	hex$(RampX(2, indx)) + CHR$(13)+chr$(10)
Next indx


Form.ShowModal

