
' General Switches.
CONST FALSE=0
CONST TRUE=1
CONST OFF=0
CONST ON=1
CONST NO=0
CONST YES=1
CONST DONT=1
CONST DOIT=0

' WTEXT_WordArt()
CONST WA18_WOOD=18

' AGENT Animation
CONST ANIM_Alert=1
CONST ANIM_Announce=2
CONST ANIM_Blink=3
CONST ANIM_Confused=4
CONST ANIM_Trophy=5
CONST ANIM_Clapping=6
CONST ANIM_Decline=7
CONST ANIM_MagicWand=8
CONST ANIM_PuffOfSmoke=9
CONST ANIM_DoNotRecognize=10
CONST ANIM_Explain=11
CONST ANIM_GestureDown=12
CONST ANIM_GestureUp=13
CONST ANIM_GestureLeft=14
CONST ANIM_GestureRight=15
CONST ANIM_GetAttention=16
CONST ANIM_Idle=17
CONST ANIM_LookDown=18
CONST ANIM_LookUp=19
CONST ANIM_LookLeft=20
CONST ANIM_LookRight=21
CONST ANIM_MoveDown=22
CONST ANIM_MoveUp=23
CONST ANIM_MoveLeft=24
CONST ANIM_MoveRight=25
CONST ANIM_Pleased=26
CONST ANIM_Process=27
CONST ANIM_Read=28
CONST ANIM_Resting=29
CONST ANIM_Sad=30
CONST ANIM_Search=31
CONST ANIM_StartListening=32
CONST ANIM_StopListening=33
CONST ANIM_Suggest=34
CONST ANIM_Surprised=35
CONST ANIM_Think=36
CONST ANIM_Uncertain=37
CONST ANIM_Wave=38
CONST ANIM_Write=39
CONST ANIM_Processing=40
CONST ANIM_Reading=41
CONST ANIM_Searching=42
CONST ANIM_Writing=43

' WFONT_SetColourIndex()
CONST ColourIndex_BLACK=1
CONST ColourIndex_BLUE=2
CONST ColourIndex_TURQUOISE=3
CONST ColourIndex_BRIGHTGREEN=4
CONST ColourIndex_PINK=5
CONST ColourIndex_RED=6
CONST ColourIndex_YELLOW=7
CONST ColourIndex_WHITE=8
CONST ColourIndex_DARKBLUE=9
CONST ColourIndex_TEAL=10
CONST ColourIndex_GREEN=11
CONST ColourIndex_VIOLET=12
CONST ColourIndex_DARKRED=13
CONST ColourIndex_DARKYELLOW=14
CONST ColourIndex_GRAY50=15
CONST ColourIndex_GRAY25=16

' WCANVAS_CreateCanvas()
CONST CANVAS1=1
CONST CANVAS2=2
CONST CANVAS3=3
CONST CANVAS4=4

' WCANVAS_DrawTextBox()
CONST TextOrientation_Normal=1
CONST TextOrientation_LeftSide=2
CONST TextOrientation_RightSide=3

' WCANVAS_DrawLine() styles
CONST Arrow_NoArrow=1
CONST Arrow_SolidArrow=2
CONST Arrow_ThinArrow=3
CONST Arrow_ThickArrow=4
CONST Arrow_DiamondArrow=5
CONST Arrow_RoundArrow=6
CONST Arrow_Width1=1
CONST Arrow_width2=2
CONST Arrow_width3=3

' WCANVAS_DrawShape()
CONST Shape_Rectangle=1
CONST Shape_Parallelogram=2
CONST Shape_Trapezoid=3
CONST Shape_Diamond=4
CONST Shape_RoundedRectangle=5
CONST Shape_Octagon=6
CONST Shape_Triangle=7
CONST Shape_RightTriangle=8
CONST Shape_Oval=9
CONST Shape_Hexagon=10
CONST Shape_Cross=11
CONST Shape_Pentagon=12
CONST Shape_Can=13
CONST Shape_Cube=14
CONST Shape_Bevel=15
CONST Shape_FoldedCorner=16
CONST Shape_Smiley=17
CONST Shape_Donut=18
CONST Shape_Prohibited=19
CONST Shape_RainbowArc=20
CONST Shape_Heart=21
CONST Shape_Lightning=22
CONST Shape_Sun=23
CONST Shape_Moon=24
CONST Shape_ThinArc=25
CONST Shape_Brackets=26
CONST Shape_Braces=27
CONST Shape_Plaque=28
CONST Shape_LeftBracket=29
CONST Shape_RightBracket=30
CONST Shape_LeftBrace=31
CONST Shape_RightBrace=32

' WSETTING_DrawLabel()
CONST Gradient_Horizontal=1
CONST Gradient_Vertical=2
CONST Gradient_DiagonalTL=3
CONST Gradient_DiagonalTR=4
CONST Gradient_DiagonalBR=5
CONST Gradient_Middle=6

' WSETTING_SetOnOff()
CONST SET_BOLD=1
CONST SET_ITALIC=2
CONST SET_UNDERLINE=3
CONST SET_STRIKETHROUGH=4
CONST SET_SMALLCAPS=5
CONST SET_SHADOW=6
CONST SET_BIUOFF=7
CONST SET_BIUON=8
CONST SET_ALLOFF=9
CONST SET_ALLON=10

' WDOCUMENT_ChangeView()
CONST SET_WEBPAGEPREVIEW=1
CONST NORMAL_VIEW=1
CONST OUTLINE_VIEW=2
CONST PRINT_VIEW=3
CONST PRINTPREVIEW_VIEW=4
CONST OUTLINE_VIEW_AGAIN=5
CONST WEB_VIEW=6

' Print TAB
CONST DraftOutput=1
CONST UpdateFields=2
CONST UpdateLinks=3
CONST AllowA4LetterPaperResizing=4
CONST BackgroundPrinting=5
CONST PrintPostScriptOverTexT=6
CONST ReversePrintOrder=7
CONST DocumentProperties=8
CONST FieldCodes=9
CONST HiddenText=10
CONST DrawingObjects=11
CONST PrintDataOnlyInForms=12
CONST FrontOfTheSheet=13
CONST BackOfTheSheet=14
CONST DefaultTray_Printer=15
CONST DefaultTray_Sheet=16

' Save TAB
CONST AlwaysCreateBackupCopy=20
CONST AllowFastSaves=21
CONST AllowBackgroundSaves=22
CONST EmbedTrueTypeFonts=23
CONST EmbedCharactersInUseOnly=24
CONST DoNotEmbedCommonSystemFonts=25
CONST Network=26
CONST SaveAutoRecoveryInfoEvery=27
CONST EmbedSmartTags=28
CONST SaveSmartTagsAsXML=29
CONST PromptForDocProperties=30
CONST PromptToSaveNormalTemplate=31
CONST SaveDataOnlyForForms=32
CONST EmbedLinguisticData=33
CONST DisableFeaturesAfterWord97=34
CONST DisableFeaturesAfterWord95=35

' Spelling & Grammar TAB
CONST CheckSpellingAsYouType=40
CONST HideSpellingErrorsInThisDoc=41
CONST ShowSpellingErrorsInThisDoc=42
CONST AlwaysSuggestSpellingCorrections=43

' General API
Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByVal dest As LONG, ByVal source As LONG, ByVal numBytes As LONG)

' MS SPEECH AGENT.
Declare Function SPEECH_Close Lib "comal.dll" Alias "SPEECH_Close" () As Long
Declare Function SPEECH_Open Lib "comal.dll" Alias "SPEECH_Open" (agentName AS STRING) As Long
Declare Function SPEECH_OpenAgent Lib "comal.dll" Alias "SPEECH_OpenAgent" (agentName AS STRING, acsPathName AS STRING) As Long
Declare Function SPEECH_SoundEffects Lib "comal.dll" Alias "SPEECH_SoundEffects" (offon AS LONG) As Long
Declare Function SPEECH_StopAnimation Lib "comal.dll" Alias "SPEECH_StopAnimation" () As Long
Declare Function AGENT_hide Lib "comal.dll" Alias "AGENT_hide" (showAgent AS LONG, playHideAnimation AS LONG) As Long
Declare Function AGENT_Speak Lib "comal.dll" Alias "AGENT_Speak" (textString AS STRING, showAgent AS LONG) As Long
Declare Function AGENT_Animate Lib "comal.dll" Alias "AGENT_Animate" (movement AS LONG) As Long
Declare Function AGENT_MoveTo Lib "comal.dll" Alias "AGENT_MoveTo" (x AS LONG, y AS LONG) As Long
Declare Function AGENT_GestureAt Lib "comal.dll" Alias "AGENT_GestureAt" (x AS LONG, y AS LONG) As Long
Declare Function AGENT_ShowPopupMenu Lib "comal.dll" Alias "AGENT_ShowPopupMenu" (x AS LONG, y AS LONG) As Long
Declare Function AGENT_Think Lib "comal.dll" Alias "AGENT_Think" (textString AS STRING, showAgent AS LONG) As Long
Declare Function AGENT_AnimateWhenIdle Lib "comal.dll" Alias "AGENT_AnimateWhenIdle" (offon AS LONG) As Long
Declare Function AGENT_ChangeSize Lib "comal.dll" Alias "AGENT_ChangeSize" (left AS LONG, top AS LONG, width AS LONG, height AS LONG) As Long

' MS WORD.
Declare Function WDOCUMENT_Close Lib "comal.dll" Alias "WDOCUMENT_Close" () As Long
Declare Function WDOCUMENT_Save Lib "comal.dll" Alias "WDOCUMENT_Save" () As Long
Declare Function WDOCUMENT_Open Lib "comal.dll" Alias "WDOCUMENT_Open" () As Long
Declare Function WDOCUMENT_GetName Lib "comal.dll" Alias "WDOCUMENT_GetName" () As Long
Declare Function WDOCUMENT_Print Lib "comal.dll" Alias "WDOCUMENT_Print" () As Long
Declare Function WDOCUMENT_ChangeView Lib "comal.dll" Alias "WDOCUMENT_ChangeView" (viewNumber AS LONG) As Long
Declare Function WORD_GetDefaultPrinter Lib "comal.dll" Alias "WORD_GetDefaultPrinter" () As Long
Declare Function WORD_SetDefaultPrinter Lib "comal.dll" Alias "WORD_SetDefaultPrinter" (printerName AS STRING) As Long
Declare Function WFONT_SetOnOff Lib "comal.dll" Alias "WFONT_SetOnOff" (command AS LONG, onOff AS LONG) As Long
Declare Function WFONT_SetSize Lib "comal.dll" Alias "WFONT_SetSize" (size AS LONG) As Long
Declare Function WFONT_SetName Lib "comal.dll" Alias "WFONT_SetName" (fontName AS STRING) As Long
Declare Function WFONT_SetColourIndex Lib "comal.dll" Alias "WFONT_SetColourIndex" (colourIndex AS LONG) As Long
Declare Function WFONT_SetFont Lib "comal.dll" Alias "WFONT_SetFont" (fontName AS STRING, fontSize AS LONG, smallCaps AS LONG, red AS LONG, green AS LONG, blue AS LONG, bold AS LONG, underline AS LONG, italic AS LONG, strikethrough AS LONG, shadow AS LONG) As Long
Declare Function WTEXT_WriteText Lib "comal.dll" Alias "WTEXT_WriteText" (text AS STRING) As Long
Declare Function WTEXT_NewParagraph Lib "comal.dll" Alias "WTEXT_NewParagraph" () As Long
Declare Function WTEXT_WordArt Lib "comal.dll" Alias "WTEXT_WordArt" (number AS LONG, textString AS STRING, fontName AS STRING, fontSize AS LONG, bold AS LONG, italic AS LONG, leftPointPos AS INTEGER, topPointPos AS INTEGER) As Long
Declare Function WTEXT_RotateArt Lib "comal.dll" Alias "WTEXT_RotateArt" (number AS LONG, rotation AS DOUBLE) As Long
Declare Function WCANVAS_CreateCanvas Lib "comal.dll" Alias "WCANVAS_CreateCanvas" (canvasNumber AS LONG, left AS LONG, top AS LONG, width AS LONG, height AS LONG) As Long
Declare Function WCANVAS_DrawTextBox Lib "comal.dll" Alias "WCANVAS_DrawTextBox" (canvasNumber AS LONG, textOrientation AS LONG, left AS LONG, top AS LONG, width AS LONG, height AS LONG, text AS STRING) As Long
Declare Function WCANVAS_DrawLine Lib "comal.dll" Alias "WCANVAS_DrawLine" (canvasNumber AS LONG, left AS LONG, top AS LONG, right AS LONG, bottom AS LONG, fgColour AS LONG, barrowLength AS LONG, barrowStyle AS LONG, barrowWidth AS LONG, earrowLength AS LONG, earrowStyle AS LONG, earrowWidth AS LONG, thickness AS LONG, lineStyle AS LONG) As Long
Declare Function WCANVAS_DrawShape Lib "comal.dll" Alias "WCANVAS_DrawShape" (canvasNumber AS LONG, shapeNumber AS LONG, left AS LONG, top AS LONG, width AS LONG, height AS LONG, lred AS LONG, lgreen AS LONG, lblue AS LONG, fred AS LONG, fgreen AS LONG, fblue AS LONG, flipit AS LONG) As Long
Declare Function WCANVAS_DrawLabel Lib "comal.dll" Alias "WCANVAS_DrawLabel" (canvasNumber AS LONG, textOrientation AS LONG, left AS LONG, top AS LONG, width AS LONG, height AS LONG, textString AS STRING, fgColour AS LONG, bgColour AS LONG, useGradient AS LONG, direction AS LONG, gradient AS LONG, fontName AS STRING, fontSize AS LONG, bold AS LONG, italic AS LONG, underline AS LONG, shadow AS LONG, strikethrough AS LONG, smallCaps AS LONG) As Long
Declare Function WINSERT_Time Lib "comal.dll" Alias "WINSERT_Time" () As Long
Declare Function WINSERT_Picture Lib "comal.dll" Alias "WINSERT_Picture" (canvasNumber AS LONG, filename AS STRING, link AS LONG, saveWithDoc AS LONG, left AS LONG, top AS LONG, width AS LONG, height AS LONG) As Long
Declare Function WINSERT_File Lib "comal.dll" Alias "WINSERT_File" (filename AS STRING,xlRange AS STRING, promptUser AS LONG) As Long
Declare Function WINSERT_Paragraph Lib "comal.dll" Alias "WINSERT_Paragraph" (text AS STRING, rangeStart AS LONG, rangeEnd AS LONG) As Long
Declare Function WSETTING_SetOnOff Lib "comal.dll" Alias "WSETTING_SetOnOff" (command AS LONG, onOff AS LONG, number AS LONG) As Long
Declare Function WSETTING_GetOnOff Lib "comal.dll" Alias "WSETTING_GetOnOff" (command AS LONG) As Long

' MS EXCEL.
Declare Function XDOCUMENT_Close Lib "comal.dll" Alias "XDOCUMENT_Close" () As Long
Declare Function XDOCUMENT_Open Lib "comal.dll" Alias "XDOCUMENT_Open" () As Long
Declare Function XSHEET_SetName Lib "comal.dll" Alias "XSHEET_SetName" (name AS STRING) As Long
Declare Function XSHEET_GetName Lib "comal.dll" Alias "XSHEET_GetName" () As Long
Declare Function XSHEET_ActivateByName Lib "comal.dll" Alias "XSHEET_ActivateByName" (sheetName AS STRING) As Long
Declare Function XSHEET_ActivateByNumber Lib "comal.dll" Alias "XSHEET_ActivateByNumber" (sheetNumber AS LONG) As Long
Declare Function XSHEET_PrintActiveSheet Lib "comal.dll" Alias "XSHEET_PrintActiveSheet" () As Long
Declare Function EXCEL_FullScreen Lib "comal.dll" Alias "EXCEL_FullScreen" (onOff AS LONG) As Long
Declare Function EXCEL_Visible Lib "comal.dll" Alias "EXCEL_Visible" (onOff AS LONG) As Long
Declare Function EXCEL_PrintAll Lib "comal.dll" Alias "EXCEL_PrintAll" (copies AS LONG, preview AS LONG, printerName AS STRING, printToFile AS LONG, collate AS LONG, ptfName AS STRING) As Long
Declare Function XCELL_WriteText Lib "comal.dll" Alias "XCELL_WriteText" (numberCoord AS LONG, LetterCoord AS LONG, name AS STRING) As Long
Declare Function XCELL_SetColour Lib "comal.dll" Alias "XCELL_SetColour" (range AS STRING, colour AS LONG) As Long
Declare Function XCELL_SetPattern Lib "comal.dll" Alias "XCELL_SetPattern" (range AS STRING, pattern AS LONG) As Long
Declare Function XCELL_SetBorderColour Lib "comal.dll" Alias "XCELL_SetBorderColour" (range AS STRING, colour AS LONG) As Long
Declare Function XCELL_SetBorderStyle Lib "comal.dll" Alias "XCELL_SetBorderStyle" (range AS STRING, style AS LONG) As Long
Declare Function XCELL_SetBorderThickness Lib "comal.dll" Alias "XCELL_SetBorderThickness" (range AS STRING, thickness AS LONG) As Long
Declare Function XCELL_SetFontSize Lib "comal.dll" Alias "XCELL_SetFontSize" (range AS STRING, fontSize AS LONG) As Long
Declare Function XCELL_WriteValue Lib "comal.dll" Alias "XCELL_WriteValue" (range AS STRING, value AS LONG) As Long
Declare Function XCELL_ReadText Lib "comal.dll" Alias "XCELL_ReadText" (range AS STRING) As Long
Declare Function XCELL_ReadValue Lib "comal.dll" Alias "XCELL_ReadValue" (range AS STRING) As DOUBLE
Declare Function XCELL_MergeCells Lib "comal.dll" Alias "XCELL_MergeCells" (range AS STRING) As Long
Declare Function XCELL_WriteMergedText Lib "comal.dll" Alias "XCELL_WriteMergedText" (range AS STRING, mergedText AS STRING) As Long
Declare Function XCELL_AddBorder Lib "comal.dll" Alias "XCELL_AddBorder" (range AS STRING, lineStyle AS LONG, thickness AS LONG, colour AS LONG) As Long
Declare Function XCELL_SetColumnWidth Lib "comal.dll" Alias "XCELL_SetColumnWidth" (range AS STRING, columnWidth AS DOUBLE) As Long
Declare Function XCELL_SelectRange Lib "comal.dll" Alias "XCELL_SelectRange" (range AS STRING) As Long
Declare Function XCELL_ClearRange Lib "comal.dll" Alias "XCELL_ClearRange" (range AS STRING) As Long
Declare Function XCELL_CopyRangeToClipboard Lib "comal.dll" Alias "XCELL_CopyRangeToClipboard" (range AS STRING) As Long
Declare Function XCELL_CutRangeToClipboard Lib "comal.dll" Alias "XCELL_CutRangeToClipboard" (range AS STRING) As Long
Declare Function XCELL_PasteRangeFromClipboard Lib "comal.dll" Alias "XCELL_PasteRangeFromClipboard" (destSheet AS STRING, destRange AS STRING) As Long

Declare Function XCELL_CopySourceToDest Lib "comal.dll" Alias "XCELL_CopySourceToDest" (sourceSheet AS STRING, sourceRange AS STRING, destSheet AS STRING, destRange AS STRING) As Long

' OFFICE AGENT.
