'
' Jpeg.dll - load jpg, jpeg, jif, gif, ico & bmp images 
'
#IFNDEF __FILE_BI__
#INCLUDE "file.bi"
#ENDIF

' Global variables to hold the function addresses
DIM SHARED JpegDLL_LoadImageFile AS FUNCTION(operand1 AS integer, BYVAL operand2 AS string) AS integer
DIM SHARED JpegDLL_ImageWidth AS FUNCTION(operand1 AS long) AS integer
DIM SHARED JpegDLL_ImageHeight AS FUNCTION(operand1 AS long) AS integer

FUNCTION LoadJpegLibrary() AS integer
DIM AS ANY PTR hndl

    IF FileExists("jpeg.dll")=0 THEN
        MessageBox(NULL,"File jpeg.dll does not exist","DLL Error",0)
        RETURN False
    END IF
    hndl=DyLibLoad("jpeg.dll")                                              ' Load the dll
    IF hndl=0 THEN
        MessageBox(NULL,"Unable to load jpeg.dll","DLL Error",0)
        RETURN False
    END IF
    JpegDLL_LoadImageFile=DyLibSymbol(hndl, "LoadImageFile")                ' Get address of first function
    IF JpegDLL_LoadImageFile=0 THEN
        MessageBox(NULL,"Unable to locate function in dll","DLL Error",0)
        RETURN False
    END IF
    JpegDLL_ImageHeight=DyLibSymbol(hndl, "ImageHeight")                    ' Get next address
    JpegDLL_ImageWidth=DyLibSymbol(hndl, "ImageWidth")                      ' Get last address
    RETURN True
END FUNCTION

